static string HOME_URL = "https://parallels.arsion.net/";


class HashValue{};class HashEntry{public:string _key;HashValue*_val;HashEntry*_next;HashEntry(){_key=NULL;_val=NULL;_next=NULL;}HashEntry(string key,HashValue*val){_key=key;_val=val;_next=NULL;}~HashEntry(){}};class HashString:public HashValue{private:string val;public:HashString(string v){val=v;}string getVal(){return val;}};class HashDouble:public HashValue{private:double val;public:HashDouble(double v){val=v;}double getVal(){return val;}};class HashInt:public HashValue{private:int val;public:HashInt(int v){val=v;}int getVal(){return val;}};class HashLong:public HashValue{private:long val;public:HashLong(datetime v){val=v;}long getVal(){return val;}};class HashDatetime:public HashValue{private:datetime val;public:HashDatetime(datetime v){val=v;}datetime getVal(){return val;}};class Hash:public HashValue{private:uint _hashSlots;int _resizeThreshold;int _hashEntryCount;HashEntry*_buckets[];bool _adoptValues;int _errCode;string _errText;void init(uint size,bool adoptValues){_hashSlots=0;_hashEntryCount=0;clearError();setAdoptValues(adoptValues);rehash(size);}uint size2prime(uint size){int pmax=ArraySize(_primes);for(int p=0;p<pmax;p++){if(_primes[p]>=size){return _primes[p];}}return size;}static uint _primes[];uint hash(string s){uchar c[];uint h=0;if(s!=NULL){h=5381;int n=StringToCharArray(s,c);for(int i=0;i<n;i++){h=((h<<5)+h)+c[i];}}return h%_hashSlots;}void clearError(){setError(0,"");}void setError(int e,string m){_errCode=e;_errText=m;}public:Hash(){init(17,true);}Hash(bool adoptValues){init(17,adoptValues);}Hash(int size,bool adoptValues){init(size,adoptValues);}~Hash(){for(uint i=0;i<_hashSlots;i++){HashEntry*nextEntry=NULL;for(HashEntry*entry=_buckets[i];entry!=NULL;entry=nextEntry){nextEntry=entry._next;if(_adoptValues&&entry._val!=NULL&&CheckPointer(entry._val)==POINTER_DYNAMIC){delete entry._val;}delete entry;}_buckets[i]=NULL;}}int getErrCode(){return _errCode;}string getErrText(){return _errText;}void setAdoptValues(bool v){_adoptValues=v;}bool getAdoptValues(){return _adoptValues;}private:uint _foundIndex;HashEntry*_foundEntry;HashEntry*_foundPrev;bool find(string keyName){bool found=false;_foundIndex=hash(keyName);if(_foundIndex>_hashSlots){setError(1,"hGet:bad hashIndex="+(string)_foundIndex+" size "+(string)_hashSlots);}else{for(HashEntry*e=_buckets[_foundIndex];e!=NULL;e=e._next){if(e._key==keyName){_foundEntry=e;found=true;break;}_foundPrev=e;}}return found;}public:HashEntry*getEntry(int i){return _buckets[i];}uint getSlots(){return _hashSlots;}int getCount(){return _hashEntryCount;}bool rehash(uint newSize){bool ret=false;HashEntry*oldTable[];uint oldSize=_hashSlots;newSize=size2prime(newSize);if(newSize<=getSlots()){setError(2,"rehash "+(string)newSize+"<="+(string)_hashSlots);}else if(ArrayResize(_buckets,newSize)!=newSize){setError(3,"unable to resize ");}else if(ArrayResize(oldTable,oldSize)!=oldSize){setError(4,"unable to resize old copy ");}else{uint i;for(i=0;i<oldSize;i++)oldTable[i]=_buckets[i];for(i=0;i<newSize;i++)_buckets[i]=NULL;_hashSlots=newSize;_resizeThreshold=(int)_hashSlots/4*3;for(uint oldHashCode=0;oldHashCode<oldSize;oldHashCode++){HashEntry*next=NULL;for(HashEntry*e=oldTable[oldHashCode];e!=NULL;e=next){next=e._next;uint newHashCode=hash(e._key);e._next=_buckets[newHashCode];_buckets[newHashCode]=e;}oldTable[oldHashCode]=NULL;}ret=true;}return ret;}bool hContainsKey(string keyName){return find(keyName);}HashValue*hGet(string keyName){HashValue*obj=NULL;clearError();bool found=false;if(find(keyName)){obj=_foundEntry._val;}else{if(!found){setError(1,"not found");}}return obj;}string hGetString(string keyName){string ret=NULL;HashString*v=hGet(keyName);if(v!=NULL){ret=v.getVal();}return ret;}double hGetDouble(string keyName){double ret=NULL;HashDouble*v=hGet(keyName);if(v!=NULL){ret=v.getVal();}return ret;}int hGetInt(string keyName){int ret=NULL;HashInt*v=hGet(keyName);if(v!=NULL){ret=v.getVal();}return ret;}long hGetLong(string keyName){long ret=NULL;HashLong*v=hGet(keyName);if(v!=NULL){ret=v.getVal();}return ret;}datetime hGetDatetime(string keyName){datetime ret=NULL;HashDatetime*v=hGet(keyName);if(v!=NULL){ret=v.getVal();}return ret;}HashValue*hPut(string keyName,HashValue*obj){HashValue*ret=NULL;clearError();if(find(keyName)){ret=_foundEntry._val;_foundEntry._val=obj;}else{HashEntry*e=new HashEntry(keyName,obj);HashEntry*first=_buckets[_foundIndex];e._next=first;_buckets[_foundIndex]=e;_hashEntryCount++;if(_hashEntryCount>_resizeThreshold){rehash(_hashSlots/2*3);}}return ret;}HashValue*hPutString(string keyName,string s){HashString*v=new HashString(s);return hPut(keyName,v);}HashValue*hPutDouble(string keyName,double d){HashDouble*v=new HashDouble(d);return hPut(keyName,v);}HashValue*hPutInt(string keyName,int i){HashInt*v=new HashInt(i);return hPut(keyName,v);}HashValue*hPutLong(string keyName,long i){HashLong*v=new HashLong(i);return hPut(keyName,v);}HashValue*hPutDatetime(string keyName,datetime i){HashDatetime*v=new HashDatetime(i);return hPut(keyName,v);}bool hDel(string keyName){bool found=false;clearError();if(find(keyName)){HashEntry*next=_foundEntry._next;if(_foundPrev!=NULL){_foundPrev._next=next;}else{_buckets[_foundIndex]=next;}if(_adoptValues&&_foundEntry._val!=NULL&&CheckPointer(_foundEntry._val)==POINTER_DYNAMIC){delete _foundEntry._val;}delete _foundEntry;_hashEntryCount--;found=true;}return found;}};uint Hash::_primes[]={17,53,97,193,389,769,1543,3079,6151,12289,24593,49157,98317,196613,393241,786433,1572869,3145739,6291469,12582917,25165843,50331653,100663319,201326611,402653189,805306457,1610612741};class HashLoop{private:uint _index;HashEntry*_currentEntry;Hash*_hash;public:HashLoop(Hash*h){setHash(h);}~HashLoop(){};void reset(){_index=0;_currentEntry=_hash.getEntry(_index);if(_currentEntry==NULL){next();}}void setHash(Hash*h){_hash=h;reset();}bool hasNext(){bool ret=(_currentEntry!=NULL);return ret;}void next(){if(_currentEntry!=NULL){_currentEntry=_currentEntry._next;}while(_currentEntry==NULL){_index++;if(_index>=_hash.getSlots())return;_currentEntry=_hash.getEntry(_index);}}string key(){if(_currentEntry!=NULL){return _currentEntry._key;}else{return NULL;}}HashValue*val(){if(_currentEntry!=NULL){return _currentEntry._val;}else{return NULL;}}int valInt(){return((HashInt*)val()).getVal();}string valString(){return((HashString*)val()).getVal();}double valDouble(){return((HashDouble*)val()).getVal();}long valLong(){return((HashLong*)val()).getVal();}datetime valDatetime(){return((HashDatetime*)val()).getVal();}};
enum ENUM_JSON_TYPE{JSON_NULL,JSON_OBJECT,JSON_ARRAY,JSON_NUMBER,JSON_STRING,JSON_BOOL};class JSONString;class JSONValue:public HashValue{private:ENUM_JSON_TYPE _type;public:JSONValue(){}~JSONValue(){}ENUM_JSON_TYPE getType(){return _type;}void setType(ENUM_JSON_TYPE t){_type=t;}bool isString(){return _type==JSON_STRING;}bool isNull(){return _type==JSON_NULL;}bool isObject(){return _type==JSON_OBJECT;}bool isArray(){return _type==JSON_ARRAY;}bool isNumber(){return _type==JSON_NUMBER;}bool isBool(){return _type==JSON_BOOL;}virtual string toString(){return "";}string getString(){return((JSONString*)GetPointer(this)).getString();}double getDouble(){return((JSONNumber*)GetPointer(this)).getDouble();}long getLong(){return((JSONNumber*)GetPointer(this)).getLong();}int getInt(){return((JSONNumber*)GetPointer(this)).getInt();}bool getBool(){return((JSONBool*)GetPointer(this)).getBool();}static bool getString(JSONValue*val,string &out){if(val!=NULL&&val.isString()){out=val.getString();return true;}return false;}static bool getBool(JSONValue*val,bool &out){if(val!=NULL&&val.isBool()){out=val.getBool();return true;}return false;}static bool getDouble(JSONValue*val,double &out){if(val!=NULL&&val.isNumber()){out=val.getDouble();return true;}return false;}static bool getLong(JSONValue*val,long &out){if(val!=NULL&&val.isNumber()){out=val.getLong();return true;}return false;}static bool getInt(JSONValue*val,int &out){if(val!=NULL&&val.isNumber()){out=val.getInt();return true;}return false;}};class JSONString:public JSONValue{private:string _string;public:JSONString(string s){setString(s);setType(JSON_STRING);}JSONString(){setType(JSON_STRING);}string getString(){return _string;}void setString(string v){_string=v;}string toString(){return StringConcatenate("\"",_string,"\"");}};class JSONBool:public JSONValue{private:bool _bool;public:JSONBool(bool b){setBool(b);setType(JSON_BOOL);}JSONBool(){setType(JSON_BOOL);}bool getBool(){return _bool;}void setBool(bool v){_bool=v;}string toString(){return(string)_bool;}};class JSONNumber:public JSONValue{private:long _long;double _dbl;public:JSONNumber(long l){_long=l;_dbl=0;}JSONNumber(double d){_long=0;_dbl=d;}long getLong(){if(_dbl!=0){return(long)_dbl;}else{return _long;}}int getInt(){if(_dbl!=0){return(int)_dbl;}else{return(int)_long;}}double getDouble(){if(_long!=0){return(double)_long;}else{return _dbl;}}string toString(){if(_long!=0){return(string)_long;}else{return(string)_dbl;}}};class JSONNull:public JSONValue{public:JSONNull(){setType(JSON_NULL);}~JSONNull(){}string toString(){return "null";}};class JSONArray;class JSONObject:public JSONValue{private:Hash*_hash;public:JSONObject(){setType(JSON_OBJECT);}~JSONObject(){if(_hash!=NULL)delete _hash;}string getString(string key){return getValue(key).getString();}bool getBool(string key){return getValue(key).getBool();}double getDouble(string key){return getValue(key).getDouble();}long getLong(string key){return getValue(key).getLong();}int getInt(string key){return getValue(key).getInt();}bool getString(string key,string &out){return getString(getValue(key),out);}bool getBool(string key,bool &out){return getBool(getValue(key),out);}bool getDouble(string key,double &out){return getDouble(getValue(key),out);}bool getLong(string key,long &out){return getLong(getValue(key),out);}bool getInt(string key,int &out){return getInt(getValue(key),out);}JSONArray*getArray(string key){return getValue(key);}JSONObject*getObject(string key){return getValue(key);}JSONValue*getValue(string key){if(_hash==NULL){return NULL;}return(JSONValue*)_hash.hGet(key);}void put(string key,JSONValue*v){if(_hash==NULL)_hash=new Hash();_hash.hPut(key,v);}string toString(){string s="{";if(_hash!=NULL){HashLoop*l;int n=0;for(l=new HashLoop(_hash);l.hasNext();l.next()){JSONValue*v=(JSONValue*)(l.val());s=StringConcatenate(s,(++n==1?"":","),"\"",l.key(),"\":",v.toString());}delete l;}s=s+"}";return s;}Hash*getHash(){return _hash;}};class JSONArray:public JSONValue{private:int _size;JSONValue*_array[];public:JSONArray(){setType(JSON_ARRAY);}~JSONArray(){for(int i=ArrayRange(_array,0)-1;i>=0;i--){if(CheckPointer(_array[i])==POINTER_DYNAMIC)delete _array[i];}}string getString(int index){return getValue(index).getString();}bool getBool(int index){return getValue(index).getBool();}double getDouble(int index){return getValue(index).getDouble();}long getLong(int index){return getValue(index).getLong();}int getInt(int index){return getValue(index).getInt();}bool getString(int index,string &out){return getString(getValue(index),out);}bool getBool(int index,bool &out){return getBool(getValue(index),out);}bool getDouble(int index,double &out){return getDouble(getValue(index),out);}bool getLong(int index,long &out){return getLong(getValue(index),out);}bool getInt(int index,int &out){return getInt(getValue(index),out);}JSONArray*getArray(int index){return getValue(index);}JSONObject*getObject(int index){return getValue(index);}JSONValue*getValue(int index){return _array[index];}bool put(int index,JSONValue*v){if(index>=_size){int oldSize=_size;int newSize=ArrayResize(_array,index+1,30);if(newSize<=index)return false;_size=newSize;for(int i=oldSize;i<newSize;i++)_array[i]=NULL;}if(_array[index]!=NULL)delete _array[index];_array[index]=v;return true;}string toString(){string s="[";if(_size>0){s=StringConcatenate(s,_array[0].toString());for(int i=1;i<_size;i++){s=StringConcatenate(s,",",_array[i].toString());}}s=s+"]";return s;}int size(){return _size;}};class JSONParser{private:int _pos;ushort _in[];int _len;string _instr;int _errCode;string _errMsg;void setError(int code=1,string msg="unknown error"){_errCode|=code;if(_errMsg==""){_errMsg="JSONParser::Error "+msg;}else{_errMsg=StringConcatenate(_errMsg,"\n",msg);}}JSONObject*parseObject(){JSONObject*o=new JSONObject();skipSpace();if(expect('{')){while(_errCode==0){skipSpace();if(_in[_pos]!='"')break;string key=parseString();if(_errCode!=0||key==NULL)break;skipSpace();if(!expect(':'))break;JSONValue*v=parseValue();if(_errCode!=0)break;o.put(key,v);skipSpace();if(!expectOptional(','))break;}if(!expect('}')){setError(2,"expected \" or}");}}if(_errCode!=0){delete o;o=NULL;}return o;}bool isDigit(ushort c){return(c>='0'&&c<='9')||c=='+'||c=='-';}bool isDoubleDigit(ushort c){return(c>='0'&&c<='9')||c=='+'||c=='-'||c=='.'||c=='e'||c=='E';}void skipSpace(){while(_in[_pos]==' '||_in[_pos]=='\t'||_in[_pos]=='\r'||_in[_pos]=='\n'){if(_pos>=_len)break;_pos++;}}bool expect(ushort c){bool ret=false;if(c==_in[_pos]){_pos++;ret=true;}else{setError(1,StringConcatenate("expected ",ShortToString(c),"(",c,")"," got ",ShortToString(_in[_pos]),"(",_in[_pos],")"));}return ret;}bool expectOptional(ushort c){bool ret=false;if(c==_in[_pos]){_pos++;ret=true;}return ret;}ushort peek(){return _in[_pos];}string parseString(){string ret="";if(expect('"')){while(true){int end=_pos;while(end<_len&&_in[end]!='"'&&_in[end]!='\\'){end++;}if(end>=_len){setError(2,"missing quote:end"+(string)end+":len"+(string)_len+":"+ShortToString(_in[_pos])+":"+StringSubstr(_instr,_pos,10)+"...");break;}if(_in[end]=='\\'){ret=ret+StringSubstr(_instr,_pos,end-_pos);end++;if(end>=_len){setError(4,"parse error after escape");}else{ushort c=0;switch(_in[end]){case '"':case '\\':case '/':c=_in[end];break;case 'b':c=8;break;case 'f':c=12;break;case 'n':c='\n';break;case 'r':c='\r';break;case 't':c='\t';break;default:setError(3,"unknown escape");}if(c==0)break;ret=ret+ShortToString(c);_pos=end+1;}}else if(_in[end]=='"'){ret=ret+StringSubstr(_instr,_pos,end-_pos);_pos=end+1;break;}}}if(_errCode!=0){ret=NULL;}return ret;}JSONValue*parseValue(){JSONValue*ret=NULL;skipSpace();string s;if(_in[_pos]=='['){ret=(JSONValue*)parseArray();}else if(_in[_pos]=='{'){ret=(JSONValue*)parseObject();}else if(_in[_pos]=='"'){s=parseString();ret=(JSONValue*)new JSONString(s);}else if(isDoubleDigit(_in[_pos])){bool isDoubleOnly=false;long l=0;long sign;int i=_pos;if(_in[_pos]=='-'){sign=-1;_pos++;}else if(_in[_pos]=='+'){sign=1;_pos++;}else{sign=1;}while(i<_len&&isDigit(_in[i])){l=l*10+(_in[i]-'0');i++;}if(isDoubleDigit(_in[i])){while(i<_len&&isDoubleDigit(_in[i])){i++;}s=StringSubstr(_instr,_pos,i-_pos);double d=sign*StringToDouble(s);ret=(JSONValue*)new JSONNumber(d);}else{l=sign*l;ret=(JSONValue*)new JSONNumber(l);}_pos=i;}else if(_in[_pos]=='t'&&StringSubstr(_instr,_pos,4)=="true"){ret=(JSONValue*)new JSONBool(true);_pos+=4;}else if(_in[_pos]=='f'&&StringSubstr(_instr,_pos,5)=="false"){ret=(JSONValue*)new JSONBool(false);_pos+=5;}else if(_in[_pos]=='n'&&StringSubstr(_instr,_pos,4)=="null"){ret=(JSONValue*)new JSONNull();_pos+=4;}else{setError(3,"error parsing value at position "+(string)_pos);}if(_errCode!=0&&ret!=NULL){delete ret;ret=NULL;}return ret;}JSONArray*parseArray(){JSONArray*ret=new JSONArray();int index=0;skipSpace();if(expect('[')){skipSpace();if(peek()!=']'){while(_errCode==0){JSONValue*v=parseValue();if(_errCode!=0)break;if(!ret.put(index++,v)){setError(3,"memory error adding "+(string)index);break;}skipSpace();if(!expectOptional(','))break;skipSpace();}}if(!expect(']')){setError(2,"list:expected,or ] ");}}if(_errCode!=0){delete ret;ret=NULL;}return ret;}public:int getErrorCode(){return _errCode;}string getErrorMessage(){return _errMsg;}JSONValue*parse( string s){int inLen;JSONValue*ret=NULL;StringTrimLeft(s);StringTrimRight(s);_instr=s;_len=StringToShortArray(_instr,_in);_pos=0;_errCode=0;_errMsg="";inLen=StringLen(_instr);if(_len!=inLen+1){setError(1,StringConcatenate("unable to create array ",inLen," got ",_len));}else{_len--;ret=parseValue();if(_errCode!=0){_errMsg=StringConcatenate(_errMsg," at ",_pos," [",StringSubstr(_instr,_pos,10),"...]");}}return ret;}};class JSONIterator{private:HashLoop*_l;public:JSONIterator(JSONObject*jo){_l=new HashLoop(jo.getHash());}~JSONIterator(){delete _l;}bool hasNext(){return _l.hasNext();}void next(){_l.next();}JSONValue*val(){return(JSONValue*)(_l.val());}string key(){return _l.key();}};
static char ExtBase64Encode[64]={ 'A','B','C','D','E','F','G','H','I','J','K','L','M','N','O','P','Q','R','S','T','U','V','W','X','Y','Z','a','b','c','d','e','f','g','h','i','j','k','l','m','n','o','p','q','r','s','t','u','v','w','x','y','z','0','1','2','3','4','5','6','7','8','9','+','/'};  static int ExtBase64Decode[256]={ -1,  -1,  -1,  -1,  -1,  -1,  -1,  -1,  -1,  -1,  -1,  -1,  -1,  -1,  -1,  -1,  -1,  -1,  -1,  -1,  -1,  -1,  -1,  -1,  -1,  -1,  -1,  -1,  -1,  -1,  -1,  -1,  -1,  -1,  -1,  -1,  -1,  -1,  -1,  -1,  -1,  -1,  -1,  62,  -1,  -1,  -1,  63,  52,  53,  54,  55,  56,  57,  58,  59,  60,  61,  -1,  -1,  -1,  -2,  -1,  -1,  -1,   0,   1,   2,   3,   4,   5,   6,   7,   8,   9,  10,  11,  12,  13,  14,  15,  16,  17,  18,  19,  20,  21,  22,  23,  24,  25,  -1,  -1,  -1,  -1,  -1,  -1,  26,  27,  28,  29,  30,  31,  32,  33,  34,  35,  36,  37,  38,  39,  40,  41,  42,  43,  44,  45,  46,  47,  48,  49,  50,  51,  -1,  -1,  -1,  -1,  -1,  -1,  -1,  -1,  -1,  -1,  -1,  -1,  -1,  -1,  -1,  -1,  -1,  -1,  -1,  -1,  -1,  -1,  -1,  -1,  -1,  -1,  -1,  -1,  -1,  -1,  -1,  -1,  -1,  -1,  -1,  -1,  -1,  -1,  -1,  -1,  -1,  -1,  -1,  -1,  -1,  -1,  -1,  -1,  -1,  -1,  -1,  -1,  -1,  -1,  -1,  -1,  -1,  -1,  -1,  -1,  -1,  -1,  -1,  -1,  -1,  -1,  -1,  -1,  -1,  -1,  -1,  -1,  -1,  -1,  -1,  -1,  -1,  -1,  -1,  -1,  -1,  -1,  -1,  -1,  -1,  -1,  -1,  -1,  -1,  -1,  -1,  -1,  -1,  -1,  -1,  -1,  -1,  -1,  -1,  -1,  -1,  -1,  -1,  -1,  -1,  -1,  -1,  -1,  -1,  -1,  -1,  -1,  -1,  -1,  -1,  -1,  -1,  -1,  -1,  -1,  -1,  -1,  -1,  -1,  -1,  -1,  -1,  -1,  -1,  -1,  -1,  -1,  -1 };  void Base64Encode(string in,string &out) { int i=0,pad=0,len=StringLen(in); while(i<len) { int b3,b2,b1=StringGetChar(in,i); i++; if(i>=len) { b2=0; b3=0; pad=2; } else { b2=StringGetChar(in,i); i++; if(i>=len) { b3=0; pad=1; } else { b3=StringGetChar(in,i); i++; } } int c1=(b1 >> 2); int c2=(((b1 & 0x3) << 4) | (b2 >> 4)); int c3=(((b2 & 0xf) << 2) | (b3 >> 6)); int c4=(b3 & 0x3f); out += CharToStr(ExtBase64Encode[c1]); out += CharToStr(ExtBase64Encode[c2]); switch(pad) { case 0: out += CharToStr(ExtBase64Encode[c3]); out += CharToStr(ExtBase64Encode[c4]); break; case 1: out += CharToStr(ExtBase64Encode[c3]); out += "="; break; case 2: out += "=="; break; } } }  void Base64Decode(string in,string &out) { int i=0,len=StringLen(in); int shift=0,accum=0; while(i<len) { int value=ExtBase64Decode[StringGetChar(in,i)]; if(value<0 || value>63) break; accum<<=6; shift+=6; accum|=value; if(shift>=8) { shift-=8; value=accum >> shift; out=out+CharToStr((char)(value & 0xFF)); } i++; } }

#import "wininet.dll"
	int InternetOpenW(string agent, int accessType, string proxyName, string proxyByPass, int flags);
	int InternetConnectW(int internet, string serverName, int port, string userName, string password, int service, int flags, int context);
	int HttpOpenRequestW(int connect, string verb, string objectName, string version, string referer, int acceptType, uint flags, int context);
	int HttpAddRequestHeadersW(int, string, int, int);
	bool HttpSendRequestW(int hRequest,string &lpszHeaders,int dwHeadersLength,uchar &lpOptional[],int dwOptionalLength);
	bool HttpQueryInfoW(int request, int infoLevel, string &buffer, int &size, int &index);
	int InternetOpenUrlW(int internetSession, string url, string header, int headerLength, int flags, int context);
	int InternetReadFile(int, uchar &arr[], int, int &byte);
	int InternetCloseHandle(int winINet);
#import

#import "user32.dll"
	int      GetAncestor(int, int);
	int      PostMessageA(int hWnd,int Msg,int wParam,int lParam);
	int      GetWindow(int hWnd,int uCmd);
	int      GetParent(int hWnd);
#import


#include <WinUser32.mqh>
// #define WM_COMMAND 0x0111

#define GA_ROOT 2
#define OP_BALANCE 6
#define OP_CREDIT 7
#define OP_REBATE 8
void EnableAllHistory()
{
    // https://www.mql5.com/ru/forum/110207/page5#401551
	// https://www.mql5.com/en/forum/147677
    #define MT4_WMCMD_ALL_HISTORY 33058
    int      main = GetAncestor(WindowHandle(Symbol(), Period()), GA_ROOT);
    PostMessageA(main, WM_COMMAND, MT4_WMCMD_ALL_HISTORY, 0);
}

//+------------------------------------------------------------------+
//|                                     arsion Local Copier.mq4      |
//|                      based On arsion Portfolio multiEA 19.095    |
//|                                  Copyright 2019, arsion Corp.    |
//|                                  Producer Tak                    |
//|                                  Author: Kaz                     |
//|                                                                  |
//|                                       https://arsion.jp          |
//+------------------------------------------------------------------+
#property copyright     "Copyright 2019 - 2024, arsion Corp."
#property link          "https://arsion.jp/"
#property version   "25.025"
static string versionString = "25.025"; //  送信用

//--- versionUp history
//  18.103 -> 18.111
//		証拠金不足無限ループエラー回避
//		マーケットが開いていない時は実行しない
//
//	18.111 -> 18.122
//		表示ラベルの一新
//		初期化時以前のトレードレスポンスをリセットし、自動売買ボタンのOn,Off途中切替に対応
//
//	18.122 -> 19.011
//		負荷分散プログラムをサーバーと共に実装
//		負荷状況に応じてリクエストを一定時間キャッシュする設定に変更
//		ファイル更新時刻のみだと競合エラーが発生するためグローバル変数も使用
//
//	19.011 -> 19.012
// 		historyの送信はマスターサーバーにする
//
//	19.012 -> 19.043
//		当システムのOEMを複数動かした場合にファイル競合が発生するのを避ける為、キャッシュ用のfilnameを変更
//
//	19.043 -> 19.044
//		cannot set timer 対策
//
//	19.051 -> 19.063
// 		一枚のチャートでマルチペア対応
//
//
// 	20.030
// 	親マジックナンバーを指定してコピー出来るバージョン

// NULL比較不整合の為""を強制代入
static string INPUT_HOME_URL = "";		//  管理画面のURL

enum bool_select
{
    bool_true = 1,      // する
    bool_false = 0,     // しない
};
//--- 設定可能パラメータ
static int inpfunds = 1000000;							//  運用資金(複利モード有効時は無効)
double funds;
enum input_compound_select
{
    select_single = 0,  	  // 無効
    select_compound = 1,      // 有効
};
static input_compound_select mode_compound = select_single;			//  複利モード
static double use_percentage = 100;					//	証拠金使用率(%)
static double fixedRate = 0.0;						//	固定為替レート(円口座以外のみ使用)
enum input_Rounding
{
    round = 0,     // 四捨五入
    ceil = 1,      // 切上げ
    floor = 2,      // 切捨て
};
static input_Rounding Rounding_Method  = round;		//  端数処理方法
static int Rounding_Digits = -2;						//  端数処理桁数(マイナス値:有効数字)


static double recoveryBoost = 0.00;					//	リカバリー係数(5=200万円に対して1ロット)
// 23.045~ 設定の手間を省く為安全機能を解除
static int AccountLeverage = 10;					//  口座のレバレッジ
static bool_select particalClose = bool_false;		//	部分決済
static bool_select ignoreLesslot = bool_false;		//	最低取引数量未満のロットをスキップ
static double fixlot = 0;							//	固定ロット
static double fixedBoost = 0;						//	マーチンゲール倍率

// 22.030~ コメント生成式修正のついでにオプション追加
static bool_select fractionComment = bool_false;		//	コメントにロットの端数値を記述
// 22.052~ 複数実行時の負荷調整の為実行間隔を変更可能に修正
static double exetimerInterval = 0.2;				//	タイマー動作間隔

/* PROXY専用箇所 */
static long parentAccount;  						//  親口座の口座番号

// 25.025~ 裁量セルフコピー専用にゼロを使用する為規定値を０->-1に変更
static long fixedParentMagic = 0;  				//  親口座のマジック指定
static int skipPositions = 0;						//	ポジション見送件数
static double startLots = 0;						//	コピー開始最低親ロット
static double maxCopyLots = 0;						//	コピー対象最大親ロット

static bool_select reverse = bool_false;				//	逆張り


//	--- 23.045~
input double inpStopLossPips = 10.0;	  //  	  損切り(PIPs)
input double inpStopLossAmount = 0.0; //	  損切り(金額)
input double inpStopLossVolatility = 0.0; //	  損切り(月ボラ/%)
input double inpStopOutMaxLoss = 0.0; //	  含み損金額で全ポジ全決済
static double unrealizedProfit;
// 指値以外での決済を停止する
static bool_select ignoreMarketOrderClose = bool_false;		//	成行決済停止


// input bool_select ignoreMagicOffset = bool_false;	//	マジックナンバーのオフセットを無視
// extern string remarks0 = "旧バージョンからのポジション引継ができます";	 //	オフセットを無視「する」を選択した場合
static int ignoreMagicOffset = bool_false;	//	マジックナンバーのオフセットを無視

static int availableMaxFund_Lv500 =  1500000;   //  150万
static int availableMaxFund_Lv400 =  5000000;   //  500万
static int availableMaxFund_Lv200 = 10000000;   // 1000万
static int availableMaxFund_LvOt = 300000000;   //  ３億

//  口座レバレッジが125未満の場合の縮小レート
static double reduce;
static int availableMaxFund;

//--- static値に日本語コメントアウト値を使用可能にする為のおまじない
#property strict

//--- コメント
// #property description   "安全のため運用資金の1.5~2倍程度の証拠金を用意して下さい。"
// #property description   "当システムは複数のマジックナンバーを使用します。"
// #property description   "システムの仕様上マジックナンバーを指定する事は出来ません。"
// #property description   "他のEAを同時使用する事は不具合発生の可能性がある為オススメしません。"
// #property description   "使用する場合はそのEAのマジックナンバーを上記範囲外に設定して下さい。"
// #property description   "但し、他のEAを同時使用した事による不具合は一切保証外となります。"
// #property description   " "
// #property description   "運用資金の上限値："
// #property description   "500倍以上:150万円 400倍以上:500万円 200倍以上:1000万円 200倍未満:３億円"
// #property description   "上記以上の数値を入力しても上限値に補正されます。"

#property icon "\\Images\\arsion.ico"

//--- 取引関係定数
static double slippagePips = 5;						//---	スリッページ(PIPS)
static int magic = 0;

//	親ポジションから生成されたマジックナンバーポインタ
static int parentMagics[];

//	保持ポジションのマジックナンバーポインタ
static int childMagics[];

static int slippage;
static JSONObject *currentPositions;

//--- 初期化時以前のトレード
static string preTradeString;
// static int preTrade[] = {};
// 21.012~ チケット番号はMT4->5でint型からulong型に変更
static ulong preTrade[] = {};


//---　経過時間
static bool busy = false;
static int initTime;
static int lastExecTime[3] = {0, 0, 0};
static double timerInterval[3] = {0.2, 50, 3};

// static JSONObject *hexdic;

//	---	19.043 -> 19.044 verUp!
// 	--- cannot set timer 対策
static bool timerEvent = false;

static int magicOffset;
static int availableMaxMagic;

// ---	20.090~ 追加オフセットで下桁同一で競合しないように
static int addOffset = 0;								//	追加オフセット

static JSONObject *openCurrencyPairs;	//	新規用ペアリスト

//	---	19.073 verUp! 非表示の通貨ペアの取引を細分化
static bool forceHiddenPairs = false;
enum symbol_select
{
    mode_all,		//	全ての通貨ペア
    mode_single,	//	チャート表示通貨ペアのみ
    // mode_visible,	//	気配値表示のみ
};
static int mode_visible = -1;
static symbol_select tradePairs = mode_all;				//	通貨ペアモード
// extern string remarks1 = "証拠金通貨関連ペアは非表示でも";	 //	「気配値表示のみ」を選択された場合
// extern string remarks2 = "EURJPY, GBPJPYは取引されます";  //  例: 円口座でEURGBPを保有していた場合
// extern string remarks3 = "詳しくはお問い合わせ下さい";		//	上記の様に強制的に取引される場合があります

static double parallelPositions[10];
static double parallelTakeprofitPips[10];
static double parallelTakeprofitAmount[10];
static string parallelComments[10] = {
	"１本目",
	"２本目",
	"３本目",
	"４本目",
	"５本目",
	"６本目",
	"７本目",
	"８本目",
	"９本目",
	"１０本目",
};


input double lotsRatio_01 = 3;			//	１本目ロット倍率
input double lotsRatio_02 = 2;			//	２本目ロット倍率
input double lotsRatio_03 = 1;			//	３本目ロット倍率
input double lotsRatio_04 = 1;			//	４本目ロット倍率
input double lotsRatio_05 = 1;			//	５本目ロット倍率
input double lotsRatio_06;			//	６本目ロット倍率
input double lotsRatio_07;			//	７本目ロット倍率
input double lotsRatio_08;			//	８本目ロット倍率
input double lotsRatio_09;			//	９本目ロット倍率
input double lotsRatio_10;			//	10本目ロット倍率

input double masterTakeprofitPips = 100;		//	元ポジ利益確定(PIPs)
input double masterTakeprofitAmount;	//	元ポジ利益確定(金額)
input double takeprofitPips_01 = 10;		//	１本目利益確定(PIPs)
input double takeprofitAmount_01;	//	１本目利益確定(金額)
input double takeprofitPips_02 = 20;		//	２本目利益確定(PIPs)
input double takeprofitAmount_02;	//	２本目利益確定(金額)
input double takeprofitPips_03 = 30;		//	３本目利益確定(PIPs)
input double takeprofitAmount_03;	//	３本目利益確定(金額)
input double takeprofitPips_04 = 40;		//	４本目利益確定(PIPs)
input double takeprofitAmount_04;	//	４本目利益確定(金額)
input double takeprofitPips_05 = 50;		//	５本目利益確定(PIPs)
input double takeprofitAmount_05;	//	５本目利益確定(金額)
input double takeprofitPips_06;		//	６本目利益確定(PIPs)
input double takeprofitAmount_06;	//	６本目利益確定(金額)
input double takeprofitPips_07;		//	７本目利益確定(PIPs)
input double takeprofitAmount_07;	//	７本目利益確定(金額)
input double takeprofitPips_08;		//	８本目利益確定(PIPs)
input double takeprofitAmount_08;	//	８本目利益確定(金額)
input double takeprofitPips_09;		//	９本目利益確定(PIPs)
input double takeprofitAmount_09;	//	９本目利益確定(金額)
input double takeprofitPips_10;		//	10本目利益確定(PIPs)
input double takeprofitAmount_10;	//	10本目利益確定(金額)

enum sel_start_point
{
    tp_01 = 0,      		// １本目利益確定後
    tp_02 = 1,      		// ２本目利益確定後
    tp_03 = 2,      		// ３本目利益確定後
    tp_04 = 3,      		// ４本目利益確定後
    tp_05 = 4,      		// ５本目利益確定後
    tp_06 = 5,      		// ６本目利益確定後
    tp_07 = 6,      		// ７本目利益確定後
    tp_08 = 7,      		// ８本目利益確定後
    tp_09 = 8,      		// ９本目利益確定後
    tp_10 = 9,      		// 10本目利益確定後
};
input sel_start_point ceiling_start = tp_03;	//	切上決済

enum sel_ceiling_point
{
    at_tp_01 = 1,      		// １本前利益確定価格
    at_tp_02 = 2,      		// ２本前利益確定価格
    at_tp_03 = 3,      		// ３本前利益確定価格
    at_tp_04 = 4,      		// ４本前利益確定価格
    at_tp_05 = 5,      		// ５本前利益確定価格
    at_tp_06 = 6,      		// ６本前利益確定価格
    at_tp_07 = 7,      		// ７本前利益確定価格
    at_tp_08 = 8,      		// ８本前利益確定価格
    at_tp_09 = 9,      		// ９本前利益確定価格
};
input sel_ceiling_point ceiling_point = at_tp_01;	//	切上場所
input bool_select trailingSelect = bool_true;		//	トレイル

// マーケットオープンフラグ 19.070~ MODE_TRADEALLOWED未対応対策
static bool marketOpen = false;
static datetime lastTimeCurrent = TimeCurrent();


static datetime AccountCreateTime;



//---　OrderModify用経過時間
static int lastModified = 0;
static bool orderModified;
static int lastModifiElapsed = 0;
//--- OrderModify最小実行インターバル(秒): 22.020~ 指値スキャルEAのコピーに対応する為に60->0に変更
static int allowedMinimumInterval = 0;


// 24.000~	トレイル用
static double trailingPips = 0.0;	//	トレイル(単位:PIPs 0.0=OFF)
string globalPrefix = (string)AccountInfoInteger(ACCOUNT_LOGIN);


// ポジション送信用
enum input_bool_select
{
    select_off = 0,     // Off
    select_on = 1,      // On
};

enum input_action
{
    mode_server = 0,	//	サーバー
    mode_readonly = 1,	//	管理集計
	mode_debug = 2,		//	デバッグ
	mode_local = 3,		//	ローカル
	mode_Google = 4,	//	Google
};
static input_bool_select hidereserve = select_on;		//	予約注文を隠す
static input_bool_select hidesl  = select_off;			//  損切値を隠す
static input_bool_select hidetp  = select_off;			//  利確値を隠す
static input_bool_select forcedStop  = select_off;		//  強制停止フラグを送信
static input_bool_select sendPosition  = select_on;		//  ポジションを送信
static input_bool_select sendHistory   = select_off;		//  ヒストリーを送信
// extern string excludeCurrency;							//	送信除外通貨(部分一致,カンマ区切り)
static string excludeCurrency;							//	送信除外通貨(部分一致,カンマ区切り)

//	23.080~ スキャル用のスプレッドマージン
static double spreadMargin;								//	スプレッドマージン(Pips相当値)

//	23.080~ 裁量ロット人為ミス防止のセーフティ機能
static int allowedMaxSize;								//	送信許容量(現物円貨/万円)

// 21.120~ サーバー版とローカル版の統合
static string A = "";	//	---------------- 動作モード ----------------
static input_action operating  = mode_local;			//  動作モード

// 22.052~ 複数実行時の負荷調整の為実行間隔を変更可能に修正
// input double localInterval = 0.2;						//	ローカルモード時の動作間隔
static double localInterval = 1.0;						//	23.080~ スキャコピーの高速化は負荷が上がるだけで意味がないので削除

static int positionTimerInterval = 15;					//	閲覧・開発時ポジション送信間隔(15秒~)
static string SERVER_NAME;
//--- 設定可能パラメータ
static string ADMIN_PASS;	//	管理画面のパスワード
// extern string masterDeployID;	//	GASのデプロイID
static string masterDeployID;	//	デプロイID(GASモード)




string FileName;
//+------------------------------------------------------------------+
//| Expert initialization function                                   |
//+------------------------------------------------------------------+
int OnInit()
{
	FileName = (string)AccountNumber()+".json";
	FileDelete(FileName, FILE_COMMON);


	if( timerInterval[0] >= 0.20 )
	{
		// 22.052~ 複数実行時の負荷調整の為実行間隔を変更可能に修正
		timerInterval[0] = exetimerInterval;
	}

	funds = inpfunds;
	compoundFix();

	// 25.025~ 裁量セルフコピー専用 (auth前に代入)
	parentAccount = AccountNumber();

	parallelPositions[0] = lotsRatio_01;
	parallelPositions[1] = lotsRatio_02;
	parallelPositions[2] = lotsRatio_03;
	parallelPositions[3] = lotsRatio_04;
	parallelPositions[4] = lotsRatio_05;
	parallelPositions[5] = lotsRatio_06;
	parallelPositions[6] = lotsRatio_07;
	parallelPositions[7] = lotsRatio_08;
	parallelPositions[8] = lotsRatio_09;
	parallelPositions[9] = lotsRatio_10;

	parallelTakeprofitPips[0] = takeprofitPips_01;
	parallelTakeprofitPips[1] = takeprofitPips_02;
	parallelTakeprofitPips[2] = takeprofitPips_03;
	parallelTakeprofitPips[3] = takeprofitPips_04;
	parallelTakeprofitPips[4] = takeprofitPips_05;
	parallelTakeprofitPips[5] = takeprofitPips_06;
	parallelTakeprofitPips[6] = takeprofitPips_07;
	parallelTakeprofitPips[7] = takeprofitPips_08;
	parallelTakeprofitPips[8] = takeprofitPips_09;
	parallelTakeprofitPips[9] = takeprofitPips_10;

	parallelTakeprofitAmount[0] = takeprofitAmount_01;
	parallelTakeprofitAmount[1] = takeprofitAmount_02;
	parallelTakeprofitAmount[2] = takeprofitAmount_03;
	parallelTakeprofitAmount[3] = takeprofitAmount_04;
	parallelTakeprofitAmount[4] = takeprofitAmount_05;
	parallelTakeprofitAmount[5] = takeprofitAmount_06;
	parallelTakeprofitAmount[6] = takeprofitAmount_07;
	parallelTakeprofitAmount[7] = takeprofitAmount_08;
	parallelTakeprofitAmount[8] = takeprofitAmount_09;
	parallelTakeprofitAmount[0] = takeprofitAmount_10;

	inpCheck();

	if( auth() )
	{
		if( fixlot <= 0 )
		{
			if( AccountLeverage >= 500 )
			{
				availableMaxFund = availableMaxFund_Lv500;
			} else if( AccountLeverage >= 400 )
			{
				availableMaxFund = availableMaxFund_Lv400;
			} else if( AccountLeverage >= 200 )
			{
				availableMaxFund = availableMaxFund_Lv200;
			} else
			{
				double div = ((funds / 100) * 0.6 + (funds / 100) * 50 / AccountLeverage) * 100;
				reduce = MathMax(div / funds, 1);
				availableMaxFund = (int)(double)(availableMaxFund_LvOt * reduce);
			}

			funds = MathMin( funds, availableMaxFund );
		}

		datetime LocalTime = TimeLocal();

		// --- 19.101~ 初期化時刻: トータル起動時間を計測
		initTime = (int)LocalTime;


		changeTF(PERIOD_H1);

		//---	チャートを、ライン表示にする
		ChartSetInteger(0, CHART_MODE, CHART_CANDLES);

		//---	zoom
		ChartSetInteger(0, CHART_SCALE, 4);

		//---	hide Grid
		ChartSetInteger(0, CHART_SHOW_GRID, false);

		//---	change color
		ChartSetInteger(0, CHART_COLOR_CHART_UP, clrForestGreen);
		ChartSetInteger(0, CHART_COLOR_CHART_DOWN, clrFireBrick);
		ChartSetInteger(0, CHART_COLOR_CANDLE_BULL, clrForestGreen);
		ChartSetInteger(0, CHART_COLOR_CANDLE_BEAR, clrFireBrick);


		//---	19.093~ 他所のPROXYのポジション引継に対応
		//---	ignoreMagicOffset が bool_trueならmagicOffset無視し、
		//---	magicOffsetが設定されていなかったバージョンのマジックナンバーに合わせる為にmagicOffsetを設定しない
		if( ignoreMagicOffset == bool_false )
		{
			//---	100 + 親口座番号下2桁: 100~199*100 = 20000000~39800000
			// magicOffset = 200000 * (int)(MathMod( parentAccount, 100 ) + 100);
			// magicOffset = 200000 * ((int)(MathMod( parentAccount, 100 ) + 100) + addOffset);

			//---	5 + 親口座番号下2桁: 5~104*100 = 100000000~2080000000 -> 120000000~2100000000
			magicOffset = 20000000 * ((int)(MathMod( parentAccount, 100 ) + 5) + addOffset);	//	20.120~

			if( reverse == bool_true )
			{
				// 24.060~ 古い逆張りオフセット変更式を除去
				// magicOffset *= 2;
			}
		} else
		{
			magicOffset = 0;
		}


		// availableMaxMagic = magicOffset + 200000;
		availableMaxMagic = magicOffset + 20000000;	//	20.120~


		// 25.025~ 裁量セルフコピー専用に裁量含む全ポジションを対象にする
		magicOffset = -1;
		availableMaxMagic = INT_MAX;


		//	---	19.072 verUp!
		//--- 途中で設定変更した場合、static変数がリセットされないので初期化時以前のトレードレスポンスをリセットし、ポジション継ぎ足しを抑止
		preTradeString = NULL;

		//	---	19.073 verUp! 非表示の通貨ペアの取引を細分化
		forceHiddenPairs = tradePairs == mode_all;

		AccountCreateTime = NULL;

		return(INIT_SUCCEEDED);
	} else
	{
		return(REASON_INITFAILED);
	}
}

void inpCheck()
{
	if( IsExpertEnabled() == true )
	{
		for( int i = 0; i < ArraySize(parallelTakeprofitPips); ++i )
		{
			if( parallelPositions[i] > 0 )
			{
				if( (masterTakeprofitPips > 0 && masterTakeprofitPips < parallelTakeprofitPips[i])
					||
					(masterTakeprofitAmount > 0 && masterTakeprofitAmount < parallelTakeprofitAmount[i])
				)
				{
					Print("元ポジが必ず最後に決済される様に設定して下さい。");
					Alert("Please set so that the master is always settled last.");

					ToggleExpert(false);

					break;
				}
			}
		}
	}

	TRADE_ENABLED_PREVIOUS = IsExpertEnabled();
}


bool ToggleExpert(bool enable)
{
	int hwnd = GetParent(GetParent(GetParent(WindowHandle(Symbol(), Period()))));
	if(hwnd == 0) return false;

	bool isExpert = IsExpertEnabled();
	if (enable && !isExpert) PostMessageW(hwnd, WM_COMMAND, 33020, 0);
	if (!enable && isExpert) PostMessageW(hwnd, WM_COMMAND, 33020, 0);

	return true;
}

//+------------------------------------------------------------------+
//| Expert deinitialization function                                 |
//+------------------------------------------------------------------+
void OnDeinit(const int reason)
{
	EventKillTimer();
	timerEvent = false;

	ObjectDelete("Version");
	ObjectDelete("Status");
	ObjectDelete("tradeAllowed");
	ObjectDelete("MagicOffset");
}


static int assetColors[] = {
	clrSeaGreen,
	clrDarkGoldenrod,
	clrLightSeaGreen,
	clrMediumVioletRed,
	clrGoldenrod,
	clrMediumSpringGreen,
	clrLawnGreen,
	clrDarkOrange,
	clrOrange,
	clrGold,
	clrYellow,
	clrDeepSkyBlue,
	clrMagenta,
	clrRed,
	clrDeepPink,
	clrMediumTurquoise,
	clrDodgerBlue,
	clrGreenYellow,
	clrCornflowerBlue,
	clrHotPink,
	clrKhaki,
	clrLightGreen,
	clrAquamarine,
	clrPaleGreen,
	clrDarkTurquoise,
	clrMediumSeaGreen,
	clrSteelBlue,
	clrYellowGreen,
	clrLimeGreen,
	clrOrangeRed,
	clrChartreuse,
	clrLime,
	clrSpringGreen,
	clrAqua,
	clrPeru,
	clrTurquoise,
	clrDarkSeaGreen,
	clrTomato,
	clrOrchid,
	clrSandyBrown,
	clrMediumSlateBlue,
	clrViolet,
	clrLightCoral,
	clrSkyBlue,
	clrLightSalmon,
	clrLightSkyBlue,
	clrLightBlue,
	clrPaleTurquoise,
	clrPink,
	clrLightCyan,
};

// 複利再計算
void compoundFix()
{
	if( mode_compound == select_compound )
	{	//	複利計算

		double vfunds = AccountBalance() + AccountCredit();
		string AccountCurrency = AccountCurrency();

		if( fixedRate <= 0 )
		{
			if( AccountCurrency != "JPY" )
			{
				double exChangeRate = MarketInfo(AccountCurrency + "JPY", MODE_BID);

				if( exChangeRate == 0 )  return;

				vfunds *= exChangeRate;
			}
		} else if( AccountCurrency != "JPY" )
		{
			vfunds *= fixedRate;
		}

		double vRounding_Digits;

		// 有効数字◯◯桁
		if( Rounding_Digits < 0 )
		{
			vRounding_Digits = StringLen((string)((int)vfunds)) + Rounding_Digits + 1;
		} else
		{
			vRounding_Digits = Rounding_Digits;
		}


		vfunds *= (use_percentage / 100);
		vfunds /= MathPow(10, vRounding_Digits - 1);

		switch( Rounding_Method )
		{
			case round:
				vfunds = MathRound(vfunds);
				break;

			case ceil:
				vfunds = MathCeil(vfunds);
				break;

			case floor:
				vfunds = MathFloor(vfunds);
				break;
		}

		vfunds *= MathPow(10, vRounding_Digits - 1);
		funds = (int)vfunds;
	}
}

static bool TRADE_ENABLED_PREVIOUS;
static int mod = 0;
//+------------------------------------------------------------------+
//| Expert tick function                                             |
//+------------------------------------------------------------------+
void OnTick()
{
	//	---	19.043 -> 19.044 verUp!
	// 	--- cannot set timer 対策
	if( timerEvent == false )
	{
		ResetLastError();

		// 22.040~: 秒スキャEAのコピーに対応する為200ms毎に対応
		EventSetMillisecondTimer((int)(timerInterval[0]*1000));
		// EventSetTimer(timerInterval[0]);

		if( GetLastError() < 1 )
		{
			timerEvent = true;
		}
	}

	if( IsExpertEnabled() != TRADE_ENABLED_PREVIOUS )
	{
		TRADE_ENABLED_PREVIOUS = !TRADE_ENABLED_PREVIOUS;
		inpCheck();
	}

	string symbol;

	if( busy == false )
	{
		datetime LocalTime;
		string tradeAllowedStatus;

		// タイマー処理に変更
		// bool marketOpen = isMarketOpened();

		if( MQLInfoInteger(MQL_TRADE_ALLOWED) && TerminalInfoInteger(TERMINAL_TRADE_ALLOWED) )
		{
			int elapsed = (int)TimeLocal() - lastExecTime[0];
			bool error = false;
			busy = true;

			string response = "";

			//	---	18.103 -> 18.111 verUp!
			if( marketOpen == true )
			{	//---	マーケットが開いているか確認

				int handle = FileOpen((string)parentAccount+".json", FILE_TXT|FILE_READ|FILE_COMMON);

				if( handle > 0 )
				{
					response = FileReadString(handle);
					FileClose(handle);
				}

				if( response == NULL )
				{
					busy = false;

					return;
				}
			} else
			{
				preTradeString  = NULL;
			}


			if( response != "" )
			{
				orderModified = false;
				lastModifiElapsed = (int)TimeLocal() - lastModified;


				//	新規建対象のペアをセット・毎ティックチェックする
				openCurrencyPairs = new JSONObject();
				int symbolsCount = SymbolsTotal(!forceHiddenPairs);

				//---	全ペアリスト
				for(int idxSymbol = 0; idxSymbol < symbolsCount; idxSymbol++)
				{
					symbol = SymbolName(idxSymbol, !forceHiddenPairs);

					//	---	24.010 verUp!取引不能ペアをスキップ
					if( SymbolInfoInteger(symbol, SYMBOL_TRADE_MODE) == SYMBOL_TRADE_MODE_DISABLED )  continue;

					//	---	19.073 verUp! チャート表示通貨ペアのみのシングルモードの時は自身以外をスキップ
					if( tradePairs == mode_single && symbol != Symbol() ) continue;

					openCurrencyPairs.put( symbol, new JSONString(symbol) );


					//	---	20.100 verUp! XMの金属対応 (Standard, Micro 両対応)
					if( StringFind(symbol, "GOLD") > -1 )
					{
						openCurrencyPairs.put( "XAUUSD", new JSONString(symbol) );
					}
					if( StringFind(symbol, "SILVER") > -1 )
					{
						openCurrencyPairs.put( "XAGUSD", new JSONString(symbol) );
					}

					//	---	22.102 verUp! 日経225 (楽天のmini, XMの限月ありを無視)
					if( StringFind(symbol, "225") > -1 && StringFind(symbol, "mini") == -1 && StringFind(symbol, "-") == -1 )
					{
						openCurrencyPairs.put( "JPN225", new JSONString(symbol) );
					}

					//	---	23.080~ SymbolSelectをBID取得失敗時のみにして負荷軽減
					if( tradePairs == mode_visible && MarketInfo(symbol, MODE_BID) == 0 )
					{
						//	---	19.073 verUp! モードが気配値表示のみの場合内部的に表示になっている気配値を表示
						SymbolSelect(symbol, true);
					}
				}

				symbolsCount = SymbolsTotal(false);
				string symbols[];
				ArrayResize(symbols, symbolsCount);
				string s;

				// ---	サフィックス対応ここから	---	//

				// 19.086~ サフィックス文字
				string suffix;
				string suffixArray[];
				int index;

				// ---	サフィックス対応1回目、ループで検索
				for(int idxSymbol = 0; idxSymbol < symbolsCount; idxSymbol++)
				{
					// アキシオリーでサフィックスはポインタアクセスエラーが出るので使えない(通常の通貨ペアでもフリーズする)
					if( StringFind(AccountCompany(), "Axiory") > -1 )
					{
						continue;
					}

					symbol = SymbolName(idxSymbol, false);

					//	---	24.010 verUp!取引不能ペアをスキップ
					if( SymbolInfoInteger(symbol, SYMBOL_TRADE_MODE) == SYMBOL_TRADE_MODE_DISABLED )  continue;

					// ポインタアクセスエラー回避
					// if( StringFind(symbol, "#") > -1 )
					// 23.100~ 先頭に#があるシンボルがポインタアクセスエラー: -1->0に変更
					if( StringFind(symbol, "#") == 0 )	//	23.070~ KIWAMI対応
					{
						continue;
					}

					symbols[idxSymbol] = symbol;

					for( int i = StringLen(symbol) - 1; i > 0; --i )
					{
						s = StringSubstr(symbol, 0, i);
						JSONValue *jv = openCurrencyPairs.getValue(s);

						if( jv != NULL )
						{
							s = jv.toString();
							StringReplace(s, "\"", "");
							openCurrencyPairs.put( s, new JSONString(symbol) );
							delete(jv);

							// 19.086~ 元シンボルがリストに存在しない場合用
							suffix = symbol;
							index = ArraySize(suffixArray);
							ArrayResize(suffixArray, index+1);
							StringReplace(suffix, s, "");
							suffixArray[index] = suffix;

							break;
						}

					}


					// 21.057 タスニック対応 サフィックスなしが1ペアもリストに存在しないブローカーに対応するにはサフィックスを直接指定して配列に入れる
					if( StringFind(symbol, "EURUSD") > -1 && symbol != "EURUSD" )
					{
						suffix = symbol;
						index = ArraySize(suffixArray);
						ArrayResize(suffixArray, index+1);
						StringReplace(suffix, "EURUSD", "");
						suffixArray[index] = suffix;
					}
				}


				string suffixToLower;

				// ---	サフィックス対応2回目、サフィックスがヒットしなかったら"."検索で"."以降の小文字をサフィックスポインタに入れる
				if( ArraySize(suffixArray) == 0 )
				{
					for(int idxSymbol = 0; idxSymbol < symbolsCount; idxSymbol++)
					{
						symbol = SymbolName(idxSymbol, false);

						//	---	24.010 verUp!取引不能ペアをスキップ
						if( SymbolInfoInteger(symbol, SYMBOL_TRADE_MODE) == SYMBOL_TRADE_MODE_DISABLED )  continue;

						symbols[idxSymbol] = symbol;

						int pos = StringFind(symbol, ".");

						if( pos > -1 )
						{
							suffix = StringSubstr(symbol, pos);
							suffixToLower = suffix;
							StringToLower(suffixToLower);

							if( suffix == suffixToLower )
							{
								index = ArraySize(suffixArray);
								ArrayResize(suffixArray, index+1);
								suffixArray[index] = suffix;
							}
						}
					}
				}


				// ---	非表示除外時、サフィックス付きからサフィックス無しを検索して、サフィックス無しをキーにして代入
				if( forceHiddenPairs == false )
				{
					for(int idxSymbol = 0; idxSymbol < symbolsCount; idxSymbol++)
					{
						if( openCurrencyPairs.getValue(symbols[idxSymbol]) != NULL )
						{
							for( int i = StringLen(symbols[idxSymbol]) - 1; i > 0; --i )
							{
								s = StringSubstr(symbols[idxSymbol], 0, i);

								if( openCurrencyPairs.getValue(s) == NULL )
								{
									for( int j = 0; j < ArraySize(symbols); ++j )
									{
										if( symbols[j] == s )
										{
											openCurrencyPairs.put( s, new JSONString(symbols[idxSymbol]) );

											break;
										}
									}
								}
							}
						}
					}
				}
				// ---	openCurrencyPairs ここまで

				// ---	サフィックス対応ここまで	---	//



				//---  親ポジション配列をリセット
				ArrayResize(parentMagics, 0);

				//---  現在のポジション配列をリセット
				currentPositions = new JSONObject();
				ArrayResize(childMagics, 0);

				//--- 全ポジションチェック
				magic = -1;

				// 23.045~ 含み損金額で全決済 後付追加機能の為static変数使用
				unrealizedProfit = 0;
				bool isStopOut = false;

				managePosition( 0 );

				// 23.045~ 含み損金額で全決済
				if( inpStopOutMaxLoss != 0 && -MathAbs(inpStopOutMaxLoss) > unrealizedProfit )
				{
					// 擬似的に親ポジションが全て決済されたものと認識させる
					response = "[]";

					isStopOut = true;
				}

				int Ticket;
				// double Divisor = MathPow(10, 5);
				double Divisor = MathPow(10, 7);	//	20.120~
				int parentAccountNumber = 0;

				JSONParser *parser = new JSONParser();
				JSONValue *jv = parser.parse(response);

				bool isInit = false;

				//--- 初期化時以前のトレードレスポンスをセット
				if( preTradeString == NULL )
				{
					isInit = true;
					preTradeString = response;

					// preTradeポインタをリセットしないと永遠に膨れるのでここで初期化する。
					// このポインタはskipOrder変数真偽を判別し、OrderSendでの新規ポジション判定のみに利用するので
					// 現在親口座が所持しているチケット番号のみ取得できれば問題ない
					ArrayResize(preTrade, 0);
				}

				if( jv != NULL && jv.isArray() )
				{
					JSONArray *orders = jv;

					if( orders != NULL )
					{
						string iKey, iVal;

						if( isInit == true )
						{
							for( int i = 0; i < orders.size(); ++i )
							{
								JSONIterator *position = new JSONIterator( orders.getValue(i) );

								for( ; position.hasNext() ; position.next())
								{
									if( position.key() == "ticket" )
									{
										iVal = position.val().toString();
										StringReplace(iVal, "\"", "");

										index = ArraySize(preTrade);
										ArrayResize(preTrade, index+1);
										preTrade[index] = (int)iVal;
									}
								}

								delete(position);
							}

							if( ArraySize(preTrade) > 0 )
							{
								ArraySort(preTrade);
							}
						}

						// 複利再計算
						compoundFix();

						// int parentTicket, parentfunds;
						// 21.012~ チケット番号はMT4->5でint型からulong型に変更
						ulong parentTicket;
						int parentfunds;
						string parentSymbol;
						double parentVolume, parentStoploss, parentTakeprofit;

						delete(parser);

						double r, totalVolume, currentVolume, volume;

						//  分割回数
						int d = 0;

						//  オーダー変数
						// ---	21.120~ openPrice: 親ポジションの注文価格の変更に対応
						double price, stoploss, takeprofit, openPrice;
						string comment = NULL;
						datetime expiration = 0;
						color arrow_color = CLR_NONE;
						bool skipOrder;
						int dirCnt[99999] = {};		//---	含損待機判別用

						// マイクロロット補正用
						double parentMarketLotSize = MarketInfo("EURUSD", MODE_LOTSIZE);
						double childMarketLotSize = parentMarketLotSize;	//	22.051~ リカバリーモード対応の為規定値を代入

						double drawdown = 0;
						// 22.051~ 損切後のリカバリーモード用ドローダウン計算
						if( recoveryBoost > 0 )
						{
							int Checked;
							double totalProfit = 0, maxProfit = 0;
							int OrderMagicNumber;
							for( int cnt = 0; cnt < OrdersHistoryTotal(); ++cnt )
							{
								Checked = OrderSelect(cnt, SELECT_BY_POS, MODE_HISTORY);
								OrderMagicNumber = OrderMagicNumber();

								if( OrderType() < 6 && OrderMagicNumber > magicOffset && OrderMagicNumber < availableMaxMagic )
								{
									totalProfit += OrderProfit() + OrderSwap() + OrderCommission();
									maxProfit = MathMax(maxProfit, totalProfit);
								}
							}

							drawdown = maxProfit - totalProfit;
							string AccountCurrency = AccountCurrency();

							if( AccountCurrency != "JPY" )
							{
								double exChangeRate = MarketInfo(AccountCurrency + "JPY", MODE_BID);

								if( exChangeRate == 0 )  exChangeRate = 100;

								drawdown *= exChangeRate;
							}
						}


						// 20.092 VerUP!!
						int dirIndex;
						string cmdToString;
						string parentMagicString;
						int parentType;
						double parentPrice;

						for( int i = 0; i < orders.size(); ++i )
						{
							JSONIterator *position = new JSONIterator( orders.getValue(i) );
							parentTicket = 0;
							parentSymbol = NULL;
							parentVolume = 0;
							parentStoploss = 0;
							parentTakeprofit = 0;
							parentfunds = 0;
							parentAccountNumber = 0;
							parentMagicString = NULL;
							parentType = -1;
							parentPrice = 0;

							for( ; position.hasNext() ; position.next())
							{
								iKey = position.key();
								iVal = position.val().toString();
								StringReplace(iVal, "\"", "");

								if( iKey == "ticket" )
								{
									parentTicket = (ulong)iVal;
								} else if( iKey == "symbol" )
								{
									// 22.031~ XM GOLDmicroの特殊ケースに対応
									// if( StringFind(iVal, "micro") > -1 )
									// {
									// 	StringReplace(iVal, "micro", "");
									// }

									// 20.103~ XMが親 / 子がXAUxxx の場合の補正
									// 22.050~ GOLDの補正を先に
									if( StringFind(iVal, "GOLD") > -1 )
									{
										StringReplace(iVal, "GOLD", "XAUUSD");
									} else if( StringFind(iVal, "SILVER") > -1 )
									{
										StringReplace(iVal, "SILVER", "XAGUSD");
									} else if( StringFind(iVal, "225") > -1 )
									{
										//	---	22.102 verUp! 日経225
										iVal = "JPN225";
									}

									// 19.101~ FX 以外にも対応するためにサフィックス削除はFXのみ
									if( StringLen(iVal) > 6 && openCurrencyPairs.getValue(iVal) == NULL  )
									{
										iVal = StringSubstr(iVal, 0, 6);
									}

									// 19.046 -> 19.051 verUP!!
									// parentSymbol = StringSubstr(iVal, 0, 6);
									parentSymbol = iVal;

								} else if( iKey == "volume" )
								{
									// reserveで既に代入されているのに０を再代入されるのを防止
									if( parentVolume == 0 )
									{
										parentVolume = (double)iVal;
									}
								} else if( iKey == "reserve" )
								{
									// volume, reserve それぞれ別にする 念の為reserveを後に設定済
									parentVolume = (double)iVal;
								} else if( iKey == "type" )
								{
									// ---	21.120~ 親ポジションの注文価格: 予約注文のコピーに対応
									parentType = (int)iVal;
								} else if( iKey == "price" )
								{
									// ---	21.120~ 親ポジションの注文価格: 予約注文のコピーに対応
									parentPrice = (double)iVal;
								} else if( iKey == "funds" )
								{
									parentfunds = (int)iVal;
								} else if( iKey == "AccountNumber" )
								{
									parentAccountNumber = (int)iVal;
								} else if( iKey == "magic" )
								{
									// 20.092~使用
									parentMagicString = (string)iVal;
								}

								//--- 逆張りOnの時はT/P, S/Lを解除するのでif分岐
								if( reverse == bool_false )
								{
									/*	Parallel Copier では サーバー送信するので隠さないが SL/TPをコピーしない為ここをコメントアウト
									if( iKey == "stoploss" )
									{
										parentStoploss = (double)iVal;
									} else if( iKey == "takeprofit" )
									{
										parentTakeprofit = (double)iVal;
									}
									*/
								}
							}

							delete(position);

							if( reverse == bool_true )
							{
								parentVolume *= -1;
							}


							//	---	19.073 verUp! モード切替に対応する為parentMagicsポインタ追加をif分岐の前に繰り上げ
							{
								// magic = (int)(MathMod(parentTicket, Divisor) + MathMod(parentAccountNumber, Divisor));

								// 25.025~ 裁量セルフコピー専用にマジックナンバー逆検索する為に必要
								magic = (int)parentTicket;

								//---	19.093~ 他所のPROXYのポジション引継に対応
								//---	ignoreMagicOffset が bool_trueならmagicOffset無視し、
								//---	magicOffsetが設定されていなかったバージョンのマジックナンバーに合わせる為にmagicOffsetを設定しない
								if( ignoreMagicOffset == bool_false )
								{
									// ---	19.044 -> 19.045 verUp! <=複数EA対策
									// ---	19.045 -> 19.046 verUp! <=0が発生した時用に1を足す
									magic += magicOffset + 1;
								}


								//	---	受信データから生成されたマジックナンバーをポインタに追加
								index = ArraySize(parentMagics);
								ArrayResize(parentMagics, index+1);
								parentMagics[index] = magic;
							}


							if( openCurrencyPairs.getValue(parentSymbol) == NULL )
							{
								// 19.086~ 元シンボルがリストに存在しない場合サフィックス付シンボル側で探す。
								for( int j = 0; j < ArraySize(suffixArray); ++ j )
								{
									if( openCurrencyPairs.getValue(parentSymbol + suffixArray[j]) != NULL )
									{
										parentSymbol += suffixArray[j];
										break;
									}
								}
							}


							if( openCurrencyPairs.getValue(parentSymbol) != NULL )
							{
								// 変数からsymbolを再セット
								symbol = openCurrencyPairs.getValue(parentSymbol).toString();
								StringReplace(symbol, "\"", "");

								//	---	23.080~ SymbolSelectをBID取得失敗時のみにして負荷軽減
								if( MarketInfo(symbol, MODE_BID) == 0 )
								{
									// 気配値表示
									SymbolSelect(symbol, true);
								}

								//  倍率
								// --- 21.082Up!! プログラミング言語の除算誤差を補正する為補正
								r = (double)(funds+0.00001) / parentfunds;

								if( parentSymbol == "JPN225" )
								{	//	---	22.102 verUp! 日経225

									childMarketLotSize = MarketInfo(symbol, MODE_LOTSIZE);

									// ---	契約サイズがブローカーによってまちまちなので、親の送信時に100で補正する
									if( childMarketLotSize != 100 )
									{
										r *= 100 / childMarketLotSize;
									}
								} else if( parentMarketLotSize > 0 && ArraySize(suffixArray) > 0 )	// マイクロロット補正
								{
									// 基準契約ロットと取引対象契約ロットの差を補正
									for( int j = 0; j < ArraySize(suffixArray); ++ j )
									{
										childMarketLotSize = MarketInfo("EURUSD"+suffixArray[j], MODE_LOTSIZE);

										if( childMarketLotSize != parentMarketLotSize && StringFind(symbol, suffixArray[j]) > -1 )
										{
											r *= parentMarketLotSize / childMarketLotSize;
											break;
										}
									}
								}

								// 25.025専用: 資金設定を無視
								r = 1;

								int cmd = -1;

								// 23.045~ PIP損切
								double stopLossPips = inpStopLossPips;
								if( StringSubstr(parentSymbol, 0, 3) == "XAU" )
								{
									stopLossPips *= 10;
								}

								if( parentVolume > 0 )
								{   //---   買い

									cmd = OP_BUY;
									cmdToString = "BUY";

									price = MarketInfo(symbol, MODE_ASK);
									arrow_color = Blue;

									if( stopLossPips > 0.0 )
									{
										// 23.045~ PIP損切
										parentStoploss = price - ( (1 / MathPow( 10, MarketInfo(symbol, MODE_DIGITS) )) * pipsToPoint(symbol) * stopLossPips );
									}

								} else if( parentVolume < 0 )
								{   //---   売り

									cmd = OP_SELL;
									cmdToString = "SELL";

									price = MarketInfo(symbol, MODE_BID);
									arrow_color = Red;

									if( stopLossPips > 0.0 )
									{
										// 23.045~ PIP損切
										parentStoploss += price + ( (1 / MathPow( 10, MarketInfo(symbol, MODE_DIGITS) )) * pipsToPoint(symbol) * stopLossPips );
									}

								} else
								{
									continue;
								}

								// continueするとparentMagics代入がされないので決済される為、ここでskipOrderを初期化、skipOrderでフラグ判別
								skipOrder = false;

								// ---	 20.041 verUP!!
								dirIndex = iConvert(parentSymbol + cmdToString + parentMagicString);
								dirCnt[dirIndex] ++;
								// dirCnt[cmd]++;		// ---	売買別にポジションをカウントし、何ポジ目かを判別する

								if( dirCnt[dirIndex] <= skipPositions )
								{	//	ポジション見送り

									skipOrder = true;
								}

								// 25.025~ 裁量セルフコピー専用にゼロを使用する為規定値を０->-1に変更
								if( fixedParentMagic > -1 && (ulong)parentMagicString != fixedParentMagic )
								{	//	21.030~	親口座のマジック指定の場合、それ以外のマジックのポジションは見送り

									skipOrder = true;
								}

								// ---	20.090 ~ 20.091 Update !!
								if( MathAbs(parentVolume) < startLots || (maxCopyLots > 0 && MathAbs(parentVolume) > maxCopyLots) )
								{	//	ナンピン系口座の低ロット・大き過ぎるロットを見送り

									skipOrder = true;
								}


								// 19.084verUp!! totalVolumeの四捨五入桁数をlotstepから計算
								double lotstep = MarketInfo(symbol, MODE_LOTSTEP);

								// 21.120verUp!! 最小取引単位が0.01ではないブローカー(Tradeview iLCやFX以外)に対応
								double minlot = MarketInfo(symbol, MODE_MINLOT);

								// 20.000~ 固定ロットでポジションを取れるオプションを追加(Copier限定機能)
								if( fixlot > 0 )
								{
									totalVolume = fixlot;

									if( fixedBoost > 0 )
									{
										// 20.102~ 固定ロットでロットマーチンオプションを追加
										totalVolume = totalVolume * MathPow(fixedBoost, dirCnt[dirIndex]-1-skipPositions);

										if( MathMod(NormalizeDouble(totalVolume, 8)*100, 1) > 0 )
										{	//	0.01未満が発生する場合はコメント記述

											comment = "absVol = " + (string)MathAbs((NormalizeDouble(totalVolume, 8)));
										} else
										{	//	端数が出ない時はコメントを初期化する

											comment = NULL;
										}
									}

									totalVolume = NormalizeDouble(totalVolume, 2);
								} else
								{
									int digits = StringFind((string)lotstep, ".") + 1;

									//  絶対値化 => 一旦切り上げ => 0.01ロット未満の切上を四捨五入に変更する為に0.005引く
									// --- 21.082Up!! プログラミング言語の除算誤差を補正する為に0.005->0.0049に変更
									totalVolume = MathFloor(r * MathAbs(parentVolume) * 10000) / 10000;


									// --- 21.082Up!! ignoreLesslot が設定されている場合、最低取引数量(0.01)未満のロットをスキップする
									// if( ignoreLesslot == bool_true && totalVolume < lotstep )
									if( ignoreLesslot == bool_true && totalVolume < minlot )
									{
										skipOrder = true;
									}


									// --- 22.030Up!! コメントを四捨五入前に生成しないと絶対に空になるので先に生成する様に順番を変更、
									// ついでにコメントのOn/Offをオプション設定出来る様に変更
									if( fractionComment == bool_true && MathMod(NormalizeDouble(totalVolume, 8)*100, 1) > 0 )
									{	//	0.01未満が発生する場合はコメント記述

										comment = "absVol = " + (string)MathAbs((NormalizeDouble(r * parentVolume, 8)));
									} else
									{	//	端数が出ない時はコメントを初期化する

										comment = NULL;
									}


									// --- 誤差補正は ignoreLesslotのスキップ判定後にする
									totalVolume -= 0.0049;

									//  小数点第3位以下切捨て、但し0になった時は強制的に0.01にする
									// totalVolume = MathMax( NormalizeDouble(totalVolume, 2), 0.01 );
									// totalVolume = MathMax( NormalizeDouble(totalVolume, digits), lotstep );
									totalVolume = MathMax( NormalizeDouble(totalVolume, digits), minlot );
								}

								if( drawdown > 0 )
								{	//	22.051~ リカバリーモード時、含損分ロット加算
									double additionalLot = drawdown / 100 / childMarketLotSize * recoveryBoost;
									totalVolume += additionalLot;
									totalVolume = NormalizeDouble(totalVolume, 2);
								}

								currentVolume = managePosition( 0 );

								if( (cmd == OP_BUY && currentVolume < 0) || (cmd == OP_SELL && currentVolume > 0) )
								{   //  途転前決済

									while( managePosition( 0 ) != 0 )
									{
										managePosition( 1 );
										//  レート変数更新
										RefreshRates();
									}

									currentVolume = 0;
								}

								// レート変動に依るボリューム変動に起因するポジション継足を防止
								if( currentVolume != 0 )
								{
									skipOrder = true;
								}

								//  差引ロット数
								totalVolume -= MathAbs(currentVolume);

								if( totalVolume > 0 )
								{   //  新規建玉

									//  ArrayBsearchバグの為forでループ
									for( int j = 0; j < ArraySize(preTrade); ++ j)
									{
										if( preTrade[j] == parentTicket )
										{
											skipOrder = true;
											break;
										}
									}


									double maxlot = MathMin( MarketInfo(symbol, MODE_MAXLOT), 100000 * lotstep );
									// 証拠金チェックを先にする為、損切り金額設定していなくても先にトータルを計算する
									volume = MathMin(totalVolume, maxlot);
									double volumeSum = volume;

									for( int j = 0; j < ArraySize(parallelPositions); ++j)
									{
										volumeSum += volume * parallelPositions[j];
									}


									//	---	18.103 -> 18.111 verUp!
									// if( AccountFreeMarginCheck(symbol, cmd, totalVolume) <= 0 || GetLastError() == ERR_NOT_ENOUGH_MONEY )
									if( AccountFreeMarginCheck(symbol, cmd, volumeSum) <= 0 || GetLastError() == ERR_NOT_ENOUGH_MONEY )
									{	//---	証拠金不足無限ループエラー回避

										skipOrder = true;
									}

									//  新規建玉は初期化時にオープン済ポジションは建てない
									if( skipOrder == false )
									{
										//---   ワンショット最大可能ロット  19.084verUP !! 最大ロット数の最大補正値を50固定ではなくlotstepの桁数から計算
										// double maxlot = MathMin( MarketInfo(symbol, MODE_MAXLOT), 50 );
										// 20.000~ 最大100ロット -> 1000ロットに拡大
										// double maxlot = MathMin( MarketInfo(symbol, MODE_MAXLOT), 100000 * lotstep );

										d = (int)MathCeil(totalVolume / maxlot);

										if( d > 1 )
										{
											// 20.120~ 分割ポジションを取った時に送信ポジションが多くなるバグを修正
											comment = NULL;
										}

										if( inpStopLossAmount > 0.0 )
										{
											// 1ロット取引したときに、最小Tickあたりに動く口座通貨ベースの金額
											double tickValue = MarketInfo(symbol, MODE_TICKVALUE);
											double pipValue = tickValue * pipsToPoint(symbol);

											if( stopLossPips > 0.0 )
											{
												// 損切り(PIPs) or 損切り(金額) どちらか早い方を優先
												stopLossPips = MathMin(stopLossPips, inpStopLossAmount / pipValue / volumeSum);
											} else
											{
												stopLossPips = inpStopLossAmount / pipValue / volumeSum;
											}

											if( cmd == OP_BUY )
											{
												parentStoploss = price - ( (1 / MathPow( 10, MarketInfo(symbol, MODE_DIGITS) )) * pipsToPoint(symbol) * stopLossPips );
											} else if( cmd == OP_SELL )
											{
												parentStoploss += price + ( (1 / MathPow( 10, MarketInfo(symbol, MODE_DIGITS) )) * pipsToPoint(symbol) * stopLossPips );
											}
										}

										if( inpStopLossVolatility > 0.0 )
										{
											double periodHigh = 0;
											double periodLow = DBL_MAX;
											double tmp;

											for( int j = 0; j < 21; ++j )
											{
												tmp = iHigh(symbol, PERIOD_D1, j);
												if( tmp == 0 )
												{
													periodHigh = 0;
													break;
												}
												periodHigh = MathMax( periodHigh, tmp );


												tmp = iLow(symbol, PERIOD_D1, j);
												if( tmp == 0 )
												{
													periodLow = 0;
													break;
												}
												periodLow = MathMin( periodLow, tmp );
											}

											if( periodHigh == 0 || periodLow == 0 )
											{
												continue;
											}

											if( cmd == OP_BUY )
											{
												if( parentStoploss > 0 )
												{
													// 損切り(PIPs) or 損切り(金額) と比較して早い方を優先
													parentStoploss = MathMax(parentStoploss, price - (periodHigh - periodLow) * (inpStopLossVolatility / 100));
												} else
												{
													parentStoploss = price - (periodHigh - periodLow) * (inpStopLossVolatility / 100);
												}
											} else if( cmd == OP_SELL )
											{
												if( parentStoploss > 0 )
												{
													// 損切り(PIPs) or 損切り(金額) と比較して早い方を優先
													parentStoploss = MathMin(parentStoploss, price + (periodHigh - periodLow) * (inpStopLossVolatility / 100));
												} else
												{
													parentStoploss = price + (periodHigh - periodLow) * (inpStopLossVolatility / 100);
												}
											}
										}

										// 25.025~ 裁量セルフコピー専用にマジックナンバー逆検索する為に必要
										magic = (int)parentTicket;

										// for( int j = 0; j < d; ++ j)
										for( int j = 0; j < ArraySize(parallelPositions); ++j)
										{
											if( parallelPositions[j] == 0 )
											{
												continue;
											}

											volume = MathMin(totalVolume, maxlot);

											// ロット倍率
											volume *= parallelPositions[j];

											//	---	19.070 -> 19.072 verUp!
											//	---	isClosed チェックを廃止
											//	---	if( volume > 0 && isClosed() == false )
											if( volume > 0 )
											{
												comment = parallelComments[j];

												double pt = pipsToPoint(symbol);
												slippage = (int)(slippagePips * pt);
												stoploss = parentStoploss;
												takeprofit = parentTakeprofit;

												// ---	21.120~ 予約注文のコピーに対応
												if( parentType > -1 )
												{
													cmd = parentType;

													// 予約注文は親の注文価格で送信する
													price = parentPrice;
												}

												if( parallelTakeprofitPips[j] > 0 )
												{
													parentTakeprofit = parallelTakeprofitPips[j] / (double)MathPow( 10, MarketInfo(symbol, MODE_DIGITS)) * (double)pipsToPoint(symbol);
													parentTakeprofit *= exceptionPips(parentSymbol);

													if( cmd == OP_BUY )
													{
														takeprofit = price + parentTakeprofit;
													} else if( cmd == OP_SELL )
													{
														takeprofit = price - parentTakeprofit;
													}
												}

												//--- メモリーリーク解消チェック済
												Ticket = OrderSend(symbol, cmd, volume, price, slippage, stoploss, takeprofit, comment, magic, expiration, arrow_color);


												//	---	19.070 -> 19.072 verUp!
												//	---	isClosed チェックの代替 オーダーが成立すれば preTradeポインタにparentTicketを追加する
												if( Ticket > -1 )
												{
													index = ArraySize(preTrade);
													ArrayResize(preTrade, index+1);
													preTrade[index] = parentTicket;
												}
											}

											// totalVolume -= maxlot;

											// 24.040~	IF分岐しないとマイナス値で部分決済エラー
											if(totalVolume > maxlot) totalVolume -= maxlot;
										}


										takeprofit = 0;
										int Checked = OrderSelect((int)parentTicket, SELECT_BY_TICKET);

										if( OrderStopLoss() == 0.0 && stopLossPips > 0.0 && parentStoploss > 0.0 )
										{
											stoploss = parentStoploss;
										}

										if( masterTakeprofitPips > 0 )
										{
											parentTakeprofit = masterTakeprofitPips / (double)MathPow( 10, MarketInfo(symbol, MODE_DIGITS)) * (double)pipsToPoint(symbol);
											parentTakeprofit *= exceptionPips(parentSymbol);

											if( cmd == OP_BUY )
											{
												takeprofit = price + parentTakeprofit;
											} else if( cmd == OP_SELL )
											{
												takeprofit = price - parentTakeprofit;
											}
										}

										if( OrderStopLoss() != stoploss || OrderTakeProfit() != takeprofit )
										{
											Checked = OrderModify( (int)parentTicket, parentPrice, stoploss, takeprofit, 0, SpringGreen );
										}
									}
								}

								//  ポジション減らす・else文使用禁止
								//--- 21.120~ 指値対応後、子口座が先に約定した場合、部分決済で全消しになる可能性を防ぐ為parentVolumeが０の時は実行しない様に修正

								/*	25.025専用: パラレルポジションを計算出来ないので廃止
								if( totalVolume < 0 && MathAbs(parentVolume) > 0 )
								{   //  一部決済

									if( cmd == OP_SELL )
									{
										totalVolume *= -1;
									}

									//--- メモリーリーク解消チェック済
									double closed = managePosition( 3, 0, 0, totalVolume );

									if( closed == 0 && particalClose == bool_true )
									{
										//--- 21.081 部分決済対応
										closed = managePosition( 9, 0, 0, totalVolume );
									}
								}
								*/

								//  ストップリミット変更・else文使用禁止 (23.045~: 但し、損切りPIPsを設定している時は変更しない)
								if( currentVolume != 0 && inpStopLossPips == 0 )
								{
									JSONIterator *pos = new JSONIterator(currentPositions);

									for( ; pos.hasNext() ; pos.next())
									{
										Ticket = (int)pos.key();
										JSONObject * o = pos.val();

										if( (int)o.getString("magic") == magic || (int)o.getString("iComment") == magic )
										{
											//--- 19.102~ クォーテーション除去ミスでstoploss/takeprofitが0になっていたのをiVal使用にて修正

											JSONValue * orderStoploss = o.getValue("stoploss");

											if( orderStoploss != NULL )
											{
												iVal = orderStoploss.toString();
												StringReplace(iVal, "\"", "");
												stoploss = (double)iVal;
											} else
											{
												stoploss = 0;
											}

											JSONValue * orderTakeprofit = o.getValue("takeprofit");

											if( orderTakeprofit != NULL )
											{
												iVal = orderTakeprofit.toString();
												StringReplace(iVal, "\"", "");
												takeprofit = (double)iVal;
											} else
											{
												takeprofit = 0;
											}


											// ---	21.120~ 予約注文価格変更に対応
											JSONValue * orderOpenPrice = o.getValue("openprice");

											if( orderOpenPrice != NULL )
											{
												iVal = orderOpenPrice.toString();
												StringReplace(iVal, "\"", "");
												openPrice = (double)iVal;
											} else
											{
												openPrice = 0;
											}

											// if( parentStoploss != stoploss || parentTakeprofit != takeprofit )
											if( parentStoploss != stoploss || parentTakeprofit != takeprofit || (parentPrice > 0 && parentPrice != openPrice) )
											{
												//--- メモリーリーク解消チェック済

												// 25.025: それぞれ決済ポイントが違うので発動させると上書きされる
												// managePosition( 2, parentStoploss, parentTakeprofit, 0, parentPrice );
											}
										}
									}

									delete(pos);
								}
							}
						}

						delete(orders);
					}

					delete(jv);
				} else
				{
					// Print("Error: failed to Load Signal");
					error = true;
				}


				if( error == false )
				{
					if( ArraySize(parentMagics) > 0 )
					{
						ArraySort(parentMagics);
					}


					int offset = (int)MathMod(parentAccountNumber, Divisor);

					if( ignoreMarketOrderClose == bool_false || isStopOut == true )
					{
						/*	23.045~
							成行決済停止フラグによるIF分岐。bool_trueなら成行手仕舞いを実行しない
							＊ 含み損金額で全決済の時は例外的に決済する
						*/

						int ordersTotal = OrdersTotal();
						int Checked, OrderMagicNumber;
						string globalName;
						double marketClosePrice, priceOffset, GlobalVariable, closeAtLeast;

						for( int i = 0; i < ArraySize(childMagics); ++i )
						{
							magic = childMagics[i];
							int m = isMagicExist(magic);

							// 24.000~	トレイル用
							// 24.040~	含み損金額で全決済とトレイルの競合防止
							if( m == -1 && trailingPips > 0.0 && isStopOut == false )
							{
								for( int cnt = 0; cnt < ordersTotal; ++cnt )
								{
									Checked = OrderSelect(cnt, SELECT_BY_POS);
									OrderMagicNumber = OrderMagicNumber();

									if( OrderMagicNumber == magic )
									{
										globalName = globalPrefix + "M" + (string)magic;
										GlobalVariable = GlobalVariableGet(globalName);

										if( OrderType() == OP_BUY )
										{
											marketClosePrice = MarketInfo( OrderSymbol(), MODE_BID );
											priceOffset = -trailingPips;
										} else if( OrderType() == OP_SELL )
										{
											marketClosePrice = MarketInfo( OrderSymbol(), MODE_ASK );
											priceOffset =  trailingPips;
										} else
										{
											continue;
										}

										priceOffset *= ( (1 / MathPow( 10, MarketInfo(OrderSymbol(), MODE_DIGITS) )) * pipsToPoint(OrderSymbol()) );
										closeAtLeast = marketClosePrice + priceOffset;

										if( GlobalVariable == 0 )
										{
											m = 1;
										} else
										{
											if( OrderType() == OP_BUY )
											{
												if( marketClosePrice > GlobalVariable )
												{
													closeAtLeast = MathMax(GlobalVariable, marketClosePrice + priceOffset);
													m = 1;
												} else if( marketClosePrice > GlobalVariable )
												{
													m = 999;
												}
											} else if( OrderType() == OP_SELL )
											{
												if( marketClosePrice < GlobalVariable )
												{
													closeAtLeast = MathMin(GlobalVariable, marketClosePrice + priceOffset);
													m = 1;
												} else if( marketClosePrice < GlobalVariable )
												{
													m = 999;
												}
											}
										}

										if( m == 1 )
										{
											GlobalVariableSet(globalName, closeAtLeast);
										}
									}
								}
							}

							if( m == -1 )
							{
								// --- メモリーリーク解消チェック済
								while( managePosition( 0 ) != 0 )
								{
									managePosition( 1 );
									//  レート変数更新
									RefreshRates();
								}
							}
						}

						// 24.000~	トレイル用
						deleteClosedGlobals();
					}
				}

				delete( openCurrencyPairs );
				delete( currentPositions );
			}

			tradeAllowedStatus = "On";
		} else
		{
			tradeAllowedStatus = "Off";

			//	---	18.111 -> 18.122 verUp!
			//--- 初期化時以前のトレードレスポンスをリセットし、自動売買ボタンのOn,Off途中切替に対応
			preTradeString  = NULL;
		}


		LocalTime = TimeLocal();
		lastExecTime[0] = (int)LocalTime;

		int size = ArraySize(assetColors);
		int i = (int)MathMod(mod, size);
		int j = 0, k;

		// int    FontColor         = Tomato;
		int    FontSize          = 24;
		string FontType          = "Tahoma";

		k = (int)MathMod(i+j, size);
		++j;
		string label = "Hikaru Parallel Copier build " + versionString;
		ObjectCreate("Version", OBJ_LABEL, 0, 0, 0);
		// ObjectSetText("Version", label, FontSize, FontType, FontColor);
		ObjectSetText("Version", label, FontSize, FontType, assetColors[k]);
		ObjectSet("Version", OBJPROP_CORNER, 2);
		ObjectSet("Version", OBJPROP_XDISTANCE, 24*1);
		ObjectSet("Version", OBJPROP_YDISTANCE, 48*3);

		label = "";

		//	---	19.073 verUp!
		if( tradePairs == mode_single )
		{
			label = Symbol() + " ";
		}

		k = (int)MathMod(i+j, size);
		++j;
		// label += (string)LocalTime + "@¥" + (string)funds + "×" + (string)AccountLeverage;

		if( fixlot > 0 )
		{
			label += (string)LocalTime + "@" + (string)NormalizeDouble(fixlot, 2) + "lot";
		} else
		{
			double strFunds = funds;
			string yenUnit = "";

			if( strFunds >= 100000000 && MathMod(strFunds, 1000000) == 0.0 )
			{
				strFunds /= 100000000;
				yenUnit = "億";
			} else if( strFunds >= 10000 && MathMod(strFunds, 100) == 0.0 )
			{
				strFunds /= 10000;
				yenUnit = "万";
			}

			// label += (string)LocalTime + "@" + (string)NormalizeDouble(strFunds, 2) + yenUnit + "円 ×" + (string)AccountLeverage;
			// 23.045~ 設定の手間を省く為安全機能を解除
			// label += (string)LocalTime + "@" + (string)NormalizeDouble(strFunds, 2) + yenUnit + "円";
			label += (string)LocalTime;
		}

		ObjectCreate("Status", OBJ_LABEL, 0, 0, 0);
		// ObjectSetText("Status", label, FontSize, FontType, FontColor);
		ObjectSetText("Status", label, FontSize, FontType, assetColors[k]);
		ObjectSet("Status", OBJPROP_CORNER, 2);
		ObjectSet("Status", OBJPROP_XDISTANCE, 24*2);
		ObjectSet("Status", OBJPROP_YDISTANCE, 48*2);

		string strategyLabel = (string)parentAccount;

		if( reverse == bool_true )
		{
			strategyLabel += "(逆張り)";
		}

		// label =  "親口座: " + strategyLabel + " / 自動売買: " + tradeAllowedStatus;
		label =  marketOpen == true && tradeAllowedStatus == "On" ? "稼働中" : "待機中";

        int elapsed = (int)TimeLocal() - initTime;

		// ---	19.100~ 1回目のmarketOpenタイマーイベントが実行される迄は閉場中表示をしない
		if( marketOpen == false && elapsed > timerInterval[1] )
		{
			// label += " (閉場中)";
		}

		k = (int)MathMod(i+j, size);
		++j;
		ObjectCreate("tradeAllowed", OBJ_LABEL, 0, 0, 0);
		// ObjectSetText("tradeAllowed", label, FontSize, FontType, FontColor);
		ObjectSetText("tradeAllowed", label, FontSize, FontType, assetColors[k]);
		ObjectSet("tradeAllowed", OBJPROP_CORNER, 2);
		ObjectSet("tradeAllowed", OBJPROP_XDISTANCE, 24*3);
		ObjectSet("tradeAllowed", OBJPROP_YDISTANCE, 48*1);

		k = (int)MathMod(i+j, size);
		++mod;

		/*
		// label = (string)"使用マジックナンバー: "+(string)(magicOffset+1)+"~"+(string)(magicOffset+200000);
		label = (string)"使用マジックナンバー: "+(string)(magicOffset+1)+"~"+(string)(magicOffset+20000000);	//	20.120~

		if( ignoreMagicOffset == bool_true )
		{
			label += " (旧版継承中)";
		}

		ObjectCreate("MagicOffset", OBJ_LABEL, 0, 0, 0);
		// ObjectSetText("MagicOffset", label, FontSize, FontType, FontColor);
		ObjectSetText("MagicOffset", label, FontSize, FontType, assetColors[k]);
		ObjectSet("MagicOffset", OBJPROP_CORNER, 2);
		ObjectSet("MagicOffset", OBJPROP_XDISTANCE, 24*4);
		ObjectSet("MagicOffset", OBJPROP_YDISTANCE, 48*0);
		*/

		if( orderModified == true )
		{
			lastModified = (int)LocalTime;
		}


        //--- ポジション情報送信
        sendPosition();

		busy = false;
	}
}

//---  ラベル表示用
static string serverResponse;
//---  最終オープン時刻
static int lastOpen;
// ポジション数最終確認時のカウント
static int lastordersCount;


static string S_suffix = NULL;
void setSuffix()
{
	if( S_suffix == NULL )
	{
		string baseSymbol = "USDJPY";
		string symbol;
		int symbolsCount = SymbolsTotal(false);

		//---	全ペアリスト
		for(int idxSymbol = 0; idxSymbol < symbolsCount; idxSymbol++)
		{
			symbol = SymbolName(idxSymbol, false);

			if( symbol != baseSymbol && StringFind(symbol, baseSymbol) == 0 )
			{
				S_suffix = StringSubstr(symbol, StringLen(baseSymbol));
				baseSymbol += S_suffix;

				if( MarketInfo(baseSymbol, MODE_BID) == 0 )
				{
					SymbolSelect(baseSymbol, true);
				}
			}
		}
	}

	if( S_suffix == NULL )
	{
		S_suffix = "";
	}
}

void sendPosition()
{
    datetime LocalTime = TimeLocal();

	if( lastOpen == 0 || marketOpen == true )
	{
		lastOpen = (int)LocalTime;
	}

	int elapsed = (int)LocalTime - lastOpen;

	//---	閉場中にも5分に1回強制的にサーバーに送信する
	int interval = 300;
	int excludeCount = 0;

	// ---	21.120~ 予約注文のコピーに対応
	bool isReserve;
	// ---	ラベル表示用のポジション数
	int currentOrders = 0, reserveOrders = 0;
	// int j, l, OrderType;
	int l, OrderType;
	string sendStatus;
	double times = 1.0;	//	閉場中のインターバルを上げる

	if( marketOpen == false )
	{
		sendStatus = " 閉場中";
		times *= 15.0;
	}

	//---	強制停止モードの時はloop数を0に変更
	int ordersTotal = forcedStop ? 0 : OrdersTotal();

	if( ordersTotal != lastordersCount )
	{	//	ポジション数が変化したら実行時刻変数をリセット

		lastExecTime[2] = 0;
	}

	int cnt = -1;

	if( S_suffix != NULL && (operating == mode_local || serverResponse == NULL || (int)(LocalTime - lastExecTime[2]) >= timerInterval[2]*times) )
	// if( operating == mode_local || serverResponse == NULL || elapsed < interval || MathMod(elapsed, interval) <= timerInterval[1] )
	{
		lastordersCount = ordersTotal;
		// lastExecTime[2] = (int)LocalTime;
		sendStatus = operating != mode_local ? " 送信完了" : "";

		int Checked, Ticket, OrderMagicNumber, parentOrderTicket;

		JSONArray *orders = new JSONArray();
		double volume;
		string comment;
		string symbol;
		// string symbols[];
		string excludes[];
		excludeCount = StringSplit(excludeCurrency, ',', excludes);


		//	---	除外ペアを送信しない
		bool skipSend;

		// ---	ローカルコピー・Google Edition専用
		string AccountNumber = (string)AccountNumber();
		string profitCurrency;
		double calcRate;
		double physicalSize, physicalPips;


		for( cnt = 0; cnt < ordersTotal; ++cnt )
		{
			Checked = OrderSelect(cnt, SELECT_BY_POS);

			skipSend = false;
			symbol = OrderSymbol();

			for( int c = 0; c < excludeCount; ++c )
			{
				if( StringFind(symbol, excludes[c]) > -1 )
				{
					skipSend = true;

				profitCurrency = SymbolInfoString(symbol, SYMBOL_CURRENCY_PROFIT);

				if( profitCurrency == "JPY" )
				{
					calcRate = 1;
				} else
				{
					profitCurrency = SymbolInfoString(symbol, SYMBOL_CURRENCY_PROFIT) + "JPY" + S_suffix;

					if( MarketInfo(profitCurrency, MODE_BID) == 0 )
					{
						SymbolSelect(profitCurrency, true);
					}

					calcRate = MarketInfo(profitCurrency, MODE_BID);
				}

				physicalSize = calcRate * volume * MarketInfo(OrderSymbol(), MODE_BID) * MarketInfo(OrderSymbol(), MODE_LOTSIZE);

				if( allowedMaxSize > 0.0 && physicalSize > allowedMaxSize*10000 )  skipSend = true;
			}


			// double unrealizedProfit = OrderProfit() + OrderSwap() + OrderCommission();
			double unrealizedPips = 0;

			OrderType = OrderType();

			if( OrderType == OP_BUY || OrderType == OP_SELL )
			{
				// 1pips相当
				physicalPips = NormalizeDouble( MarketInfo(symbol, MODE_BID) / 10000, 8 );

				if( physicalPips > 0 )
				{
					double OrderClosePrice;

					if( OrderType == OP_BUY )
					{
						OrderClosePrice = MarketInfo(symbol, MODE_BID);
						unrealizedPips = (OrderClosePrice - OrderOpenPrice());

					} else if( OrderType == OP_SELL )
					{
						OrderClose

					unrealizedPips /= physicalPips;
				}
			}

			Ticket = OrderTicket();

			// 23.080~ スキャルEAを親口座にした時用のスプレッドマージン
			if( spreadMargin > 0 )
			{
				// 19文字_19文字 = 39文字/64文字以内
				string globalName = globalPrefix + (string)Ticket;

				if( -unrealizedPips > spreadMargin && GlobalVariableGet(globalName) == 0 )
				{
					GlobalVariableSet(globalName, TimeLocal());
				} OrderMagicNumber();
			/*
			if( OrderType == OP_SELL )
			{
				volume *= -1;
			} else if( OrderType != OP_BUY )
			{
				// 待機注文をスキップ

				continue;
			}
			*/

			if( OrderType != OP_SELL && OrderType != OP_BUY )
			{
				++reserveOrders;

				// 予約注文を隠す設定の時は予約注文をスキップする
				if( hidereserve == select_on )
				{
					continue;
				}
			} else
			{
				++currentOrders;
			}


			// ---	21.120~ 予約注文のコピーに対応
			if( OrderType == OP_SELL || OrderType == OP_SELLLIMIT || OrderType == OP_SELLSTOP )
			{
				volume *= -1;
			}

			JSONObject *order = new JSONObject();
			order.put( "symbol", new JSONString( symbol ) );

			if( iClose(symbol, PERIOD_D1, 21) == 0 )
			{
				SymbolSelect(symbol, true);
			}

			if( OrderMagicNumber > 0 )
			{
				order.put( "magic", new JSONString( (string)OrderMagicNumber ) );
			}

			// V004
			order.put( "stoploss", new JSONString( hidesl == 0 ? (string)OrderStopLoss() : "0" ) );
			order.put( "takeprofit", new JSONString( hidetp == 0 ? (string)OrderTakeProfit() : "0" ) );

			if( operating == mode_local || operating == mode_Google )
			{
				//---	ローカルコピー・GAS専用
				//---	GAS版では複数親アカウントを廃止してJSONをパースせずにそのまま返す様に形式を変更
				order.put( "funds", new JSONString( (string)funds ) );
				order.put( "AccountNumber", new JSONString( AccountNumber ) );
			}

			parentOrderTicket = parentOrder(Ticket);

			//  検索ループでチケットポインタ移動するので必ず最後に
			order.put( "ticket", new JSONString( (string)parentOrderTicket ) );
			l = 1;

			if( OrderMagicNumber > 0 )
			{
				comment = OrderComment();

				if( StringSubstr(comment, 0, 9) == "absVol = " )
				{
					volume = (double)StringSubstr(comment, 9, StringLen(comment));

					if( OrderType == OP_SELL )
					{
						volume *= -1;
					}
				}
			}


			//	---	22.102 verUp! 日経225の契約サイズを100で補正する
			if( StringFind(symbol, "225") > -1 )
			{
				double LotSize = MarketInfo(symbol, MODE_LOTSIZE);
				volume /= 100 / LotSize;
			}


			// order.put( "volume", new JSONString( (string)volume ) );

			// ---	21.120~ 予約注文のコピーに対応
			isReserve = false;
			if( OrderType != OP_BUY && OrderType != OP_SELL )  isReserve = true;

			if( isReserve == true )
			{
				order.put( "volume", new JSONString( (string)0 ) );
				order.put( "reserve", new JSONString( (string)volume ) );
			} else
			{
				order.put( "volume", new JSONString( (string)volume ) );
			}


			if( isReserve == true )
			{
				order.put( "type", new JSONString( (string)OrderType ) );
			}

			order.put( "price", new JSONString( (string)OrderOpenPrice() ) );
			orders.put( orders.size(), order );
		}
		/*
		if( compound == select_on )
		{
			funds = MathMax( AccountBalance() + AccountCredit(), AccountEquity() );

			if( risk_percentage > 0 )
			{
				funds *= 100 / risk_percentage;
			}

			string AccountCurrency = AccountCurrency();

			if( AccountCurrency != "JPY" )
			{
				double exChangeRate = MarketInfo(AccountCurrency + "JPY", MODE_BID);

				if( exChangeRate == 0 )  return;

				funds *= exChangeRate;
			}


			int len = MathMax( StringLen( (string)((int)funds) ) - 2, 4 );
			int unit = (int)MathPow(10, len);
			funds += unit - MathMod( funds, unit );
		}
		*/


		// if( operating == mode_local )
		{
			string js = orders.toString();

			//--- ローカルファイル書込
			int handle = FileOpen(FileName, FILE_WRITE | FILE_TXT | FILE_COMMON);
			FileWrite(handle, js);
			FileClose(handle);
			// delete(orders);
		} //else

		if( serverResponse == NULL || (int)(LocalTime - lastExecTime[2]) >= timerInterval[2]*times )
		{
			lastExecTime[2] = (int)LocalTime;

			JSONObject *sendParams = new JSONObject();
			sendParams.put( "funds", new JSONString((string)funds) );
			sendParams.put( "orders", orders );

			if( forcedStop == 1 )
			{
				sendParams.put( "forcedStop", new JSONString((string)true) );
			}

			/*
			if( operating > 0 )
			{
				string operarating", new JSONString(operating_mode) );
			}
			*/

			sendParams.put( "operating", new JSONString("readonly") );
			string enc = "";
			string js = sendParams.toString();
			delete(sendParams);
			Base64Encode(js, enc);
ddddddddddd
			// serverResponse = AccessToInternetGetMethod("share", "orders=" + enc);
			if(sendPosition == select_on)
			{
				serverResponse = AccessToInternetPostMethod("share", "orders=" + enc);
			} else
			{
				sendStatus = "";
			}
		}

		delete(orders);
	}
}


	string strType;
	datetime now = TimeLocal();

	for( int i = 0; i < GlobalVariablesTotal(); ++i )
	{
		globalName = GlobalVariableName(i);
		skipDel = false;

		if( StringFind(globalName, globalPrefix) == 0 && (int)(now - GlobalVariableTime(globalName)) > 900 )
		{
			StringReplace(globalName, globalPrefix, "");
			strType = String
					Checked = OrderSelect(cnt, SELECT_BY_POS);

					if( (strType == "M" && OrderMagicNumber() == uValue) || (strType == "T" && OrderTicket() == uValue) )
					{
						skipDel = true;
						break;
					}
				}

				if( skipDel == false )  GlobalVariableDel(globalPrefix + strType + globalName);
			}
		}
	}
}


int isMagicExist( int magicNumber )
{
	if( ArraySize(parentMagics) > 0 )
	{
		int s = ArrayBsearch(parentMagics, magicNumber);

		if( s > -1 && parentMagics[s] == magicNumber )
		{
			return s;
		}
	}

	return -1;
}


//+------------------------------------------------------------------+
//| Timer function                                                   |
//+------------------------------------------------------------------+
void OnTimer()
{
	setSuffix();

	//---	取引コマンド
	OnTick( );



	datetime LocalTime = TimeLocal();
	int elapsed = (int)LocalTime - lastExecTime[1];
	if( elapsed > timerInterval[1] )
	{
		// ドメイン指定したら履歴送信
		if( HOME_URL != NULL )  AccessToInternetGetMethod("history");

		lastExecTime[1] = (int)LocalTime;

		deleteClosedGlobals();

		// マーケットオープンフラグを更新
		isMarketOpened();
		EnableAllHistory();
	}
	//+-----------------------------------------------+
}


bool auth()
{
	if( IsTesting() )
	{
		Print("当EAはロジックの性質上ストラテジーテスターはご利用になれません。");
	} else
	{
		if( parentAccount <= 0 )
		{
			Print("親口座の口座番号を設定して下さい。");
			Alert("error! Please Show Expert Tab On Terminal Window");
		} else if( !MQLInfoInteger(MQL_TRADE_ALLOWED) )
		{
			Print("自動売買が許可されていません。「自動売買を許可する」のチェックボックスをONにして下さい。");
			Alert("Please Show Expert Tab On Terminal Window");
			Alert("Automated trading is forbidden!!");
		} else if( IsDllsAllowed() == false )
		{
			Print("DLLの呼び出しに失敗しました。DLLの使用を許可して下さい。");
			Alert("Please Show Expert Tab On Terminal Window");
			Alert("DLL disallowed!!");
		} else if( funds < 10000 && fixlot <= 0 )
		{
			Print("設定可能最低運用資金は1万円です。");
			Alert("Please Show Expert Tab On Terminal Window");
			Alert("Not Enough Money!!");
			Alert("At Least Need 10000 yen as Setting Value");
		} else
		{
			string response;

			if( INPUT_HOME_URL != "" )
			{
				HOME_URL = INPUT_HOME_URL;

				if( StringFind(HOME_URL, "://") > -1 )
				{
					StringReplace(HOME_URL, "http://", "https://");
				} else
				{
					HOME_URL = "https://" + HOME_URL;
				}

				if( StringSubstr(HOME_URL, StringLen(HOME_URL)-1) != "/" )
				{
					HOME_URL += "/";
				}

				response = AccessToInternetGetMethod("auth");
			} else
			{
				response = "ok";
			}


			if( response != NULL && response != "ng" )
			{
				ResetLastError();

				// 22.040~: 秒スキャEAのコピーに対応する為200ms毎に対応
				EventSetMillisecondTimer((int)(timerInterval[0]*1000));
				// EventSetTimer(timerInterval[0]);

				if( GetLastError() < 1 )
				{
					timerEvent = true;
				}

				return true;
			} else
			{
				Print("認証に失敗しました。管理画面に口座を登録するか、管理画面のURLを未入力にして履歴送信を無効化して下さい。");
				Alert("Please Show Expert Tab On Terminal Window");
				Alert("authorization Faied!!");
			}
		}
	}

	return false;
}


int pipsToPoint(string symbol)
{
	double digits = MarketInfo(symbol, MODE_DIGITS);

	// 3桁/5桁のFX業者の場合
	if(digits == 3.0 || digits == 5.0)
	{
		return 10;
	} else
	{
		return 1;
	}
}

double exceptionPips( string symbol )
{
	if( StringFind(symbol, "XAU") > -1 || StringFind(symbol, "GOLD") > -1 )
	{
		return 10;
	}

	return 1;
}


int iConvert( string text )
{
	int ret = 1;
	uchar buf[];

	StringToCharArray(text, buf);

	for( int i = 0; i < ArraySize(buf); ++i)
	{
		ret += buf[i] * (i+1);
		// ret += buf[i];
	}

	return ret;
}


void isCeilingStarted( int TargetMagicNumber, datetime OrderOpenTime, double &price, bool &ceilingStarted )
{
	int Checked, OrderMagicNumber, OrderType, elapsed, pos;
	string comment;
	int startPoint = -1;

	for( int cnt = OrdersHistoryTotal() - 1; cnt >= 0; --cnt )
	{
		Checked = OrderSelect(cnt, SELECT_BY_POS, MODE_HISTORY);
		elapsed = (int)(OrderOpenTime - OrderOpenTime());

		if( elapsed > 60 )
		{
			continue;
		}

		OrderMagicNumber = OrderMagicNumber();
		OrderType = OrderType();

		if( OrderType < 6
			&&
			((OrderMagicNumber == 0 && OrderTicket() == TargetMagicNumber) || (OrderMagicNumber > 0 && OrderMagicNumber == TargetMagicNumber))
		)
		{
			comment = OrderComment();
			pos = StringFind(comment, "[");

			if( pos > -1 )
			{
				comment = StringSubstr(comment, 0, pos);
			}

			for( int i = ArraySize(parallelComments) - 1; i >= 0; --i )
			{
				if( parallelComments[i] == comment )
				{
					if( ceilingStarted == false && ((trailingSelect == bool_true && i >= ceiling_start) || i == ceiling_start) )
					{
						ceilingStarted = true;
						startPoint = i;
					}

					if( ceilingStarted == true && i == startPoint - ceiling_point )
					{
						price = OrderClosePrice();
					}
				}
			}

			if( ceilingStarted == true && startPoint - ceiling_point == -1 )
			{
				// N個前が引数マイナス１の場合に建値決済
				price = OrderOpenPrice();
			}
		}
	}
}

double managePosition( int mode, double StopLoss = 0, double TakeProfit = 0, double volume = 0, double parentPrice = 0 )
{
	if( mode == 2 )
	{
		//---	許可されたインターバル未満での連続注文変更はしない
		if( lastModifiElapsed < allowedMinimumInterval )
		{
			return 0;
		}
	}


	int cnt, Checked, ticket, index;
	double total = 0;
	int ordersTotal = OrdersTotal();
	double lots;
	double totalVolume = 0;
	bool skip;
	string symbol;
	int OrderMagicNumber, iComment;
	double price;
	bool ceilingStarted;

	//for( cnt = 0; cnt < ordersTotal; ++cnt )
	for( cnt = ordersTotal-1; cnt >= 0; --cnt )
	{   //  後ろから => 最後に取ったポジションを優先

		Checked = OrderSelect(cnt, SELECT_BY_POS);

		//  先に決済するポジションのチケット番号を確定させておく
		ticket = OrderTicket();
		OrderMagicNumber = OrderMagicNumber();

		// 特例対策1: マジックがチケット番号にすり替わっていた場合はその値は無効なのでマジックを0としてEA監視の対象外にする
		if( ticket == OrderMagicNumber )
		{
			OrderMagicNumber = 0;
		}

		// 特例対策2: マジックが異常値になって注文を探せなくなるのを防ぐ為予めマジックをコメントにセットしていたものを呼び出す
		iComment = (int)OrderComment();

		// if( OrderSymbol() == symbol && OrderMagicNumber > 0 && (magic == -1 || magic == OrderMagicNumber) && OrderMagicNumber <= 999999 )

		/* ---	19.044 -> 19.045 verUp! <=複数EA対策
			・[> 0 (1~)] を magicOffset以上に変更
			・<= 999999 を < availableMaxMagic に変更 (イコール含まず)
		*/

		// if( OrderMagicNumber > magicOffset && (magic == -1 || magic == OrderMagicNumber) && OrderMagicNumber < availableMaxMagic )
		/* ---	19.101~ <=特殊対策
			magicがTicketに差し変わる場合の特例でコメントにマジックナンバーを入れて判別
		*/
		if(
			( OrderMagicNumber > magicOffset && (magic == -1 || magic == OrderMagicNumber) && OrderMagicNumber < availableMaxMagic )
			||
			( iComment > magicOffset && (magic == -1 || magic == iComment) && iComment < availableMaxMagic )
		)
		{
			lots = OrderLots();
			double profitAmount = OrderProfit() + OrderSwap() + OrderCommission();

			if( magic == -1 )
			{
				JSONObject *order = new JSONObject();
				order.put( "magic", new JSONString( (string)OrderMagicNumber ) );
				order.put( "volume", new JSONString( (string)lots ) );
				order.put( "stoploss", new JSONString( (string)OrderStopLoss() ) );
				order.put( "takeprofit", new JSONString( (string)OrderTakeProfit() ) );

				// ストップリミット変更用
				order.put( "iComment", new JSONString( (string)iComment ) );

				// ---	21.120~ 予約注文価格変更に対応
				order.put( "openprice", new JSONString( (string)OrderOpenPrice() ) );

				currentPositions.put( (string)ticket, order );

				if( OrderMagicNumber > 0 )
				{	//	OrderMagicNumberを0に変更した場合は追加しない

					index = ArraySize(childMagics);
					ArrayResize(childMagics, index+1);
					childMagics[index] = OrderMagicNumber;
				}

				if( iComment > 0 && OrderMagicNumber != iComment )
				{
					// 特例対策
					index = ArraySize(childMagics);
					ArrayResize(childMagics, index+1);
					childMagics[index] = iComment;
				}
			}


			if( mode == 9 )
			{	// 21.081 部分決済対応

				if( MathAbs(volume) > 0 )
				{
					double CloseLots = MathAbs(volume);
					double targetVolumePercentage = CloseLots / lots * 100;

					if( targetVolumePercentage >= 5 )
					{
						symbol = OrderSymbol();
						CloseLots = NormalizeDouble(CloseLots, 2);

						// if( CloseLots >= 0.01 )
						//	---	22.102 verUp! 0.01 -> 最小取引単位に変更
						if( CloseLots >= MarketInfo(symbol, MODE_MINLOT) )
						{
							string globalName;
							double marketClosePrice, priceOffset, GlobalVariable, closeAtLeast;
							int m;
							globalName = globalPrefix + "T" + (string)ticket;
							GlobalVariable = GlobalVariableGet(globalName);
							priceOffset = ( (1 / MathPow( 10, MarketInfo(symbol, MODE_DIGITS) )) * pipsToPoint(symbol) );
							m = -1;

							if( OrderType() == OP_BUY && volume < 0 )
							{
								marketClosePrice = MarketInfo( symbol, MODE_BID );
								priceOffset *= -trailingPips;
								closeAtLeast = marketClosePrice + priceOffset;

								if( GlobalVariable == 0 )
								{
									m = 1;
								} else
								{
									if( marketClosePrice > GlobalVariable )
									{
										closeAtLeast = MathMax(GlobalVariable, marketClosePrice + priceOffset);
										m = 1;
									} else if( marketClosePrice > GlobalVariable )
									{
										m = 999;
									}
								}

								if( m == 1 )
								{
									GlobalVariableSet(globalName, closeAtLeast);
								} else if( m == -1 )
								{
									Checked = OrderClose(ticket, CloseLots, MarketInfo(symbol, MODE_BID), slippage, Green);
								}
							} else if( OrderType() == OP_SELL && volume > 0 )
							{
								marketClosePrice = MarketInfo( symbol, MODE_ASK );
								priceOffset *= trailingPips;
								closeAtLeast = marketClosePrice + priceOffset;

								if( GlobalVariable == 0 )
								{
									m = 1;
								} else
								{
									if( marketClosePrice < GlobalVariable )
									{
										closeAtLeast = MathMin(GlobalVariable, marketClosePrice + priceOffset);
										m = 1;
									} else if( marketClosePrice < GlobalVariable )
									{
										m = 999;
									}
								}

								if( m == 1 )
								{
									GlobalVariableSet(globalName, closeAtLeast);
								} else if( m == -1 )
								{
									Checked = OrderClose(ticket, CloseLots, MarketInfo(symbol, MODE_ASK), slippage, Green);
								}
							}

							if( Checked > 0 )
							{
								return CloseLots;
							}
						}
					}
				}

			} else if( mode == 3 )
			{   //  一部決済

				if( MathAbs(volume) != lots )
				{
					skip = true;
					totalVolume = lots;

					//for( int i = cnt + 1; i < ordersTotal; ++i )
					for( int i = cnt - 1; i >= 0; --i )
					{   //  後ろから => 最後に取ったポジションを優先

						Checked = OrderSelect(i, SELECT_BY_POS);

						if( OrderMagicNumber() == magic )
						{
							totalVolume += OrderLots();

							if( NormalizeDouble(totalVolume, 2) == MathAbs(volume) )
							{
								if( NormalizeDouble( lots - OrderLots(), 2 ) == 0.01 )
								{
									//  微調整継足防止の為、0.01の端数が出た場合少ない方を先に決済
									ticket = OrderTicket();
								}

								skip = false;
								break;
							}
						}
					}

					if( skip == true )
					{
						continue;
					}
				}

				if( OrderType() == OP_BUY && volume < 0 )
				{
					symbol = OrderSymbol();
					Checked = OrderClose(ticket, OrderLots(), MarketInfo(symbol, MODE_BID), slippage, Green);

					if( Checked > 0 )
					{
						return 1;
					}

				} else if( OrderType() == OP_SELL && volume > 0 )
				{
					symbol = OrderSymbol();
					Checked = OrderClose(ticket, OrderLots(), MarketInfo(symbol, MODE_ASK), slippage, Green);

					if( Checked > 0 )
					{
						return 1;
					}

				}
			} else if( OrderType() == OP_BUY || OrderType() == OP_BUYLIMIT || OrderType() == OP_BUYSTOP )
			{
				switch( mode )
				{
					// ポジションチェック
					case 0:
						total += lots;

						if( OrderType() == OP_BUY )
						{
							symbol = OrderSymbol();

							// 価格取得失敗で獲得PIPsがー無限値になる
							if( MarketInfo(symbol, MODE_BID) == 0 )
							{
								break;
							}

							if( (OrderStopLoss() > 0.0 && MarketInfo(symbol, MODE_BID) < OrderStopLoss())
							 	||
								(OrderTakeProfit() > 0.0 && MarketInfo(symbol, MODE_BID) > OrderTakeProfit())
							)
							{
								Checked = OrderClose(ticket, OrderLots(), MarketInfo(symbol, MODE_BID), slippage, Green);
								total -= lots;
							}

							double profitPips = (MarketInfo(symbol, MODE_BID) - OrderOpenPrice()) * MathPow( 10, MarketInfo(symbol, MODE_DIGITS)) / pipsToPoint(symbol);
							profitPips /= exceptionPips(symbol);

							string comment = OrderComment();

							for( int i = 0; i < ArraySize(parallelComments); ++i )
							{
								if(
									(OrderMagicNumber == 0 &&
										((masterTakeprofitPips > 0.0 && profitPips > masterTakeprofitPips)
										||
										(masterTakeprofitAmount > 0.0 && profitAmount > masterTakeprofitAmount))
									)
									||
									(comment == parallelComments[i] &&
										((parallelTakeprofitPips[i] > 0.0 && profitPips > parallelTakeprofitPips[i])
										||
										(parallelTakeprofitAmount[i] > 0.0 && profitAmount > parallelTakeprofitAmount[i]))
									)
								 )
								{
									Checked = OrderClose(ticket, OrderLots(), MarketInfo(symbol, MODE_BID), slippage, Green);
									total -= lots;

									break;
								}
							}
						}


						price = 0;
						ceilingStarted = false;
						isCeilingStarted( OrderMagicNumber > 0 ? OrderMagicNumber : ticket, OrderOpenTime(), price, ceilingStarted );

						// 再選択
						Checked = OrderSelect(cnt, SELECT_BY_POS);

						if( ceilingStarted == true && price > 0 && price != OrderStopLoss() )
						{
							// トレールスタート

							Checked = OrderModify( ticket, OrderOpenPrice(), price, OrderTakeProfit(), 0, SpringGreen );
						}

						break;

					// 手仕舞い
					case 1:
						if( OrderType() > OP_BUY )
						{
							// ---	21.120~ 予約注文取消
							Checked = OrderDelete( ticket, CLR_NONE );
						} else
						{
							symbol = OrderSymbol();
							Checked = OrderClose(ticket, OrderLots(), MarketInfo(symbol, MODE_BID), slippage, Green);
						}

						break;

					// 利確値変更
					case 2:
						if( StopLoss == 0 )
						{
							StopLoss = OrderStopLoss();
						}

						if( TakeProfit == 0 )
						{
							TakeProfit = OrderTakeProfit();
						}

						// ---	21.120~ 予約注文価格変更に対応
						if( parentPrice == 0 )
						{
							parentPrice = OrderOpenPrice();
						}

						Checked = OrderModify( ticket, parentPrice, StopLoss, TakeProfit, 0, SpringGreen );
						orderModified = true;
						break;
				}
			} else if( OrderType() == OP_SELL || OrderType() == OP_SELLLIMIT || OrderType() == OP_SELLSTOP )
			{
				switch( mode )
				{
					// ポジションチェック
					case 0:
						total -= lots;

						if( OrderType() == OP_SELL )
						{
							symbol = OrderSymbol();

							// 価格取得失敗で獲得PIPsが＋無限値になる
							if( MarketInfo(symbol, MODE_ASK) == 0 )
							{
								break;
							}

							if( (OrderStopLoss() > 0 && MarketInfo(symbol, MODE_ASK) > OrderStopLoss())
								||
								(OrderTakeProfit() > 0 && MarketInfo(symbol, MODE_ASK) < OrderTakeProfit())
							)
							{
								Checked = OrderClose(ticket, OrderLots(), MarketInfo(symbol, MODE_ASK), slippage, Green);
								total -= lots;
							}

							double profitPips = (OrderOpenPrice() - MarketInfo(symbol, MODE_ASK)) * MathPow( 10, MarketInfo(symbol, MODE_DIGITS)) / pipsToPoint(symbol);
							profitPips /= exceptionPips(symbol);

							string comment = OrderComment();

							for( int i = 0; i < ArraySize(parallelComments); ++i )
							{
								if(
									(OrderMagicNumber == 0 &&
										((masterTakeprofitPips > 0.0 && profitPips > masterTakeprofitPips)
										||
										(masterTakeprofitAmount > 0.0 && profitAmount > masterTakeprofitAmount))
									)
									||
									(comment == parallelComments[i] &&
										((parallelTakeprofitPips[i] > 0.0 && profitPips > parallelTakeprofitPips[i])
										||
										(parallelTakeprofitAmount[i] > 0.0 && profitAmount > parallelTakeprofitAmount[i]))
									)
								 )
								{
									Checked = OrderClose(ticket, OrderLots(), MarketInfo(symbol, MODE_ASK), slippage, Green);
									total -= lots;

									break;
								}
							}
						}


						price = 0;
						ceilingStarted = false;
						isCeilingStarted( OrderMagicNumber > 0 ? OrderMagicNumber : ticket, OrderOpenTime(), price, ceilingStarted );

						// 再選択
						Checked = OrderSelect(cnt, SELECT_BY_POS);

						if( ceilingStarted == true && price > 0 && price != OrderStopLoss() )
						{
							// トレールスタート

							Checked = OrderModify( ticket, OrderOpenPrice(), price, OrderTakeProfit(), 0, SpringGreen );
						}

						break;

					// 手仕舞い
					case 1:
						if( OrderType() > OP_SELL )
						{
							// ---	21.120~ 予約注文取消
							Checked = OrderDelete( ticket, CLR_NONE );
						} else
						{
							symbol = OrderSymbol();
							Checked = OrderClose(ticket, OrderLots(), MarketInfo(symbol, MODE_ASK), slippage, Green);
						}

						break;

					// 利確値変更
					case 2:
						if( StopLoss == 0 )
						{
							StopLoss = OrderStopLoss();
						}

						if( TakeProfit == 0 )
						{
							TakeProfit = OrderTakeProfit();
						}

						// ---	21.120~ 予約注文価格変更に対応
						if( parentPrice == 0 )
						{
							parentPrice = OrderOpenPrice();
						}

						Checked = OrderModify( ticket, parentPrice, StopLoss, TakeProfit, 0, SpringGreen );
						orderModified = true;
						break;
				}
			}

			// 23.045~ 含み損金額で全決済
			unrealizedProfit += OrderProfit() + OrderSwap() + OrderCommission();
		}
	}


	return total;
}


string AccessToInternetGetMethod(string action)
{
	int handle;
	string s, filename;

	if( action != "auth" && action != "status" )
	{
		//	---	19.012 -> 19.043 verUp!
		// 当システムのOEMを複数動かした場合にファイル競合が発生するのを避ける為、filnameを変更
		// string filename = hexConvert("encode", action);
		filename = hexConvert("encode", HOME_URL+action);

		int now = (int)TimeLocal();

		handle = FileOpen(filename, FILE_TXT | FILE_READ);

		if( handle > 0 )
		{
			double expireLimit;
			s = FileReadString(handle);

			if( action == "share" )
			{
				expireLimit = timerInterval[0];
			} else
			{
				expireLimit = timerInterval[1];
			}

			int modified = (int)FileGetInteger(handle, FILE_MODIFY_DATE);
			FileClose(handle);

			if( now - modified < expireLimit )
			{
				if( StringLen(s) > 0 )
				{
					s = hexConvert("decode", s);
				}

				return(s);
			}
		}
		//--- ローカルキャッシュ読込


		// string globalName = hexConvert("encode", versionString) + "." + filename;
		string globalName = hexConvert("encode", HOME_URL+versionString+action);
		int lastExec = (int)GlobalVariableGet(globalName);

		if( now - lastExec == 0 )
		{
			Sleep(100);
			return AccessToInternetGetMethod(action);
		}


		//--- グローバル変数
		datetime ExecTime = TimeLocal();
		GlobalVariableSet(globalName, ExecTime);
	}

	string url;

	if( action == "auth" )
	{
		url = HOME_URL + "auth.php";
	} else
	{
		url = HOME_URL + "trade/";
	}


	string str = "?action=" + action
			+ "&Version=" + versionString
			+ "&AccountNumber=" + (string)AccountNumber()
			+ "&Balance=" + (string)(AccountBalance() + AccountCredit())
			+ "&Funds=" + (string)funds
			+ "&Equity=" + (string)AccountEquity()

			//	---	18.111 -> 18.122 verUp!
			//  --- 19.051 -> 19.063 verUpでマルチペア対応の為廃止
			// + "&Symbol=" + Symbol()

			// 	---	19.104~ 保有ポジション数を送信
			+ "&OrdersTotal=" + (string)OrdersTotal()

			+ "&Company=" + (string)AccountCompany();

			//	---	19.100~ EAを1ファイルにして認証キーで判別 ~ 自動コンパイル搭載により廃止
			// + "&authkey=" + (string)authkey;



	if( action != "share" )
	{	//	19.100~ 1時間毎のタイマー時にアセット金額を送信

		double balance = depositsAndWithdrawals();
		str += "&assetBalance=" + (string)balance;
	}


	url += str;

	string result = "";
	int byte_size = 0;
	uchar receive[1024];
	int inet = InternetOpenW("MetaTrader 4 Terminal", 0, "0", "0", 0);

	if(inet == 0) return(NULL);

	handle = InternetOpenUrlW(inet, url, NULL, 0, 0, 0);

	while( InternetReadFile(handle, receive, 1024, byte_size ) )
	{
		if(byte_size <= 0) break;

		result += CharArrayToString(receive, 0, byte_size, CP_UTF8);
	}

	InternetCloseHandle(handle);
	InternetCloseHandle(inet);

	if( action != "auth" && action != "status" )
	{
		s = result;

		if( StringLen(result) > 0 )
		{
			s = hexConvert("encode", s);
		}

		//--- ローカルキャッシュ書込
		handle = FileOpen(filename, FILE_WRITE | FILE_TXT);
		FileWrite(handle, s);
		FileClose(handle);
	}

	return(result);
}
//+------------------------------------------------------------------+



//+------------------------------------------------------------------+
//| 文字列相互変換                                                     |
//+------------------------------------------------------------------+
string hexConvert( string mode, string text )
{
	string ret;
	uchar buf[];

	if( mode == "encode" )
	{
		StringToCharArray(text, buf);

		ret = ArrayToHex(buf);
	} else if( mode == "decode" )
	{
		ArrayResize(buf, StringLen(text)/2);
		HexToArray(text, buf);

		ret = CharArrayToString(buf);
	}

	return ret;
}
string ArrayToHex(uchar &arr[],int count=-1)
{
	string res = "";

	//--- 10進数 -> 16進数
	for( int i = 0; i < ArraySize(arr); ++i)
	{
		res += StringFormat("%.2X", arr[i]);
	}

	return(res);
}
bool HexToArray(string str, uchar &arr[])
{
	int arrcount = ArraySize(arr);
	int strcount = StringLen(str);
	if (arrcount < strcount / 2) return false;

	int i=0, j=0;

	for (i=0; i<strcount; i+=2)
	{
		string sub = StringSubstr(str, i, 2);
		uchar tmpchr = HexToDecimal(StringSubstr(str, i, 1))*16 + HexToDecimal(StringSubstr(str, i+1, 1));
		arr[j] = tmpchr;
		j++;
	}

	return true;
}
uchar HexToDecimal(string hex)
{
	// assumes hex is 1 character
	if (!StringCompare(hex, "0"))
		return 0;
	if (!StringCompare(hex, "1"))
		return 1;
	if (!StringCompare(hex, "2"))
		return 2;
	if (!StringCompare(hex, "3"))
		return 3;
	if (!StringCompare(hex, "4"))
		return 4;
	if (!StringCompare(hex, "5"))
		return 5;
	if (!StringCompare(hex, "6"))
		return 6;
	if (!StringCompare(hex, "7"))
		return 7;
	if (!StringCompare(hex, "8"))
		return 8;
	if (!StringCompare(hex, "9"))
		return 9;
	if (!StringCompare(hex, "A"))
		return 10;
	if (!StringCompare(hex, "B"))
		return 11;
	if (!StringCompare(hex, "C"))
		return 12;
	if (!StringCompare(hex, "D"))
		return 13;
	if (!StringCompare(hex, "E"))
		return 14;
	if (!StringCompare(hex, "F"))
		return 15;
	return 0;
}
//+------------------------------------------------------------------+


void changeTF(int eintTF)
{
	int intParent = GetParent( WindowHandle( Symbol(), Period() ) );
	int intChild = GetWindow( intParent, 0 );
	int intCmd = NULL;

	switch( eintTF )
	{
		case PERIOD_M1:   intCmd = 33137;  break;
		case PERIOD_M5:   intCmd = 33138;  break;
		case PERIOD_M15:  intCmd = 33139;  break;
		case PERIOD_M30:  intCmd = 33140;  break;
		case PERIOD_H1:   intCmd = 35400;  break;
		case PERIOD_H4:   intCmd = 33136;  break;
		case PERIOD_D1:   intCmd = 33134;  break;
		case PERIOD_W1:   intCmd = 33141;  break;
		case PERIOD_MN1:  intCmd = 33334;  break;
	}

	PostMessageA( intParent, 0x0111, intCmd, 0 );
}


void isMarketOpened()
{
	datetime now = TimeCurrent();
	bool flag = lastTimeCurrent != now;
	lastTimeCurrent = now;

	marketOpen = flag;
}


double depositsAndWithdrawals()
{
	if( AccountCreateTime == NULL )
	{
		EnableAllHistory();
	}

	int cnt, Checked, orderType;
	double balance = 0;

    for( cnt = 0; cnt < OrdersHistoryTotal(); ++cnt )
    {
        Checked = OrderSelect(cnt, SELECT_BY_POS, MODE_HISTORY);

		if( AccountCreateTime == NULL )
		{
			AccountCreateTime = OrderOpenTime();
		} else if( cnt == 0 && AccountCreateTime < OrderOpenTime() )
		{	//	---	途中で履歴期間が変更された場合は再度全履歴を表示させる為に初期化

			AccountCreateTime = NULL;
			return depositsAndWithdrawals();
		}


		orderType = OrderType();

		if( orderType == OP_BALANCE || orderType == OP_CREDIT )
		{
			balance += OrderProfit();
		}
    }

	return NormalizeDouble(balance, AccountCurrency() == "JPY" ? 0 : 2);
}



//+------------------------------------------------------------------+
//| 分割決済の親チケットナンバー検索                                      |
//+------------------------------------------------------------------+
int parentOrder( int Ticket )
{
    int parentOrder;
    string comment = OrderComment();

    if( StringSubstr(comment, 0, 6) == "from #" )
    {
        Ticket = (int)StringSubstr(comment, 6, StringLen(comment));

        while( (parentOrder = searchparentOrder(Ticket)) != Ticket )
        {
            Ticket = parentOrder;
        }
    }

    return Ticket;
}


int searchparentOrder( int Ticket )
{
    int cnt, Checked;
    int historyTotal = OrdersHistoryTotal();

    for( cnt = historyTotal-1; cnt >= 0; --cnt )
    {
        if( (Checked = OrderSelect(cnt, SELECT_BY_POS, MODE_HISTORY)) > 0 )
        {
            if( OrderComment() == "to #"+(string)Ticket )
            {
                Ticket = OrderTicket();

                break;
            }
        }
    }

    return Ticket;
}


#define DEFAULT_HTTPS_PORT     443
#define SERVICE_HTTP   3
#define FLAG_SECURE            0x00800000  // use PCT/SSL if applicable (HTTP)
#define FLAG_PRAGMA_NOCACHE    0x00000100  // asking wininet to add "pragma: no-cache"
#define FLAG_KEEP_CONNECTION   0x00400000  // use keep-alive semantics
#define FLAG_RELOAD            0x80000000  // retrieve the original item

string AccessToInternetPostMethod(string action, string query = "")
{
	string url;

	{
		string host, poststr, Object;
		uint codepage;

		{
			host = HOME_URL;
			StringReplace(host, "http://", "https://");
			StringReplace(host, "https://", "");

			if( StringSubstr(host, StringLen(host)-1) == "/" )
			{
				host = StringSubstr(host, 0, StringLen(host)-1);
			}

			url = HOME_URL + (action == "auth" ? "auth.php" : "trade/");


			poststr = "action=" + action
					+ "&Version=" + versionString
					+ "&AccountNumber=" + (string)AccountNumber()
					+ "&Balance=" + (string)(AccountBalance() + AccountCredit())
					+ "&Funds=" + (string)funds
					+ "&Equity=" + (string)AccountEquity()

					//	---	19.110~ 保有ポジション数を送信
					+ "&OrdersTotal=" + (string)OrdersTotal()

					+ "&Company=" + (string)AccountCompany();

			if( query != "" )
			{
				poststr += "&" + query;
			}


			if( action != "share" )
			{	//	21.120~ 受信EA用のアセット金額送信機能を統合

				double balance = depositsAndWithdrawals();
				poststr += "&assetBalance=" + (string)balance;
			}

			Object  = (action == "auth" ? "/auth.php" : "/trade/");

			codepage = CP_ACP;
		}


		// POST
		int session = 0; int connect = 0;
		int hRequest, hSend;
		uchar post[];
		ArrayResize(post, StringToCharArray(poststr, post, 0, WHOLE_ARRAY, CP_UTF8) - 1);

		string UserAgent = "MetaTrader 4 Terminal";
		string nill = "";

		session = InternetOpenW(UserAgent, 0, nill, nill, 0);

		if(session <= 0)
		{
			if(session > 0)  InternetCloseHandle(session); session = -1;
			if(connect > 0)  InternetCloseHandle(connect); connect = -1;

			// Print("Err CreateSession");

			return(NULL);
		}

		connect = InternetConnectW(session, host, DEFAULT_HTTPS_PORT, nill, nill, SERVICE_HTTP, 0, 0);

		if(connect <= 0)
		{
			if(session > 0)  InternetCloseHandle(session);  session = -1;
			if(connect > 0)  InternetCloseHandle(connect);  connect = -1;

			// Print("Err create Connect");

			return(NULL);
		}


		hRequest = HttpOpenRequestW(connect, "POST", Object, "HTTP/1.1", nill, NULL, FLAG_SECURE|FLAG_KEEP_CONNECTION|FLAG_RELOAD|FLAG_PRAGMA_NOCACHE, 0);

		if(hRequest <= 0)
		{
			if(session > 0)  InternetCloseHandle(session);  session = -1;
			if(connect > 0)  InternetCloseHandle(connect);  connect = -1;

			// Print("Err OpenRequest");

			return(NULL);
		}

		string headers = "Content-Type: application/x-www-form-urlencoded\r\n";
		hSend = HttpSendRequestW(hRequest, headers, StringLen(headers), post, ArraySize(post));
		uchar ch[1024];
		string toStr = "";
		int dwBytes;

		while( InternetReadFile(hRequest, ch, 1024, dwBytes) )
		{
			if(dwBytes <= 0) break;
			toStr = CharArrayToString(ch, 0, dwBytes, codepage);
		}


		if(hSend <= 0)
		{
			// Print("Err SendRequest");
			if(connect > 0)  InternetCloseHandle(hRequest);
			if(session > 0)  InternetCloseHandle(session);  session  = -1;
			if(connect > 0)  InternetCloseHandle(connect);  connect  = -1;
		}

		InternetCloseHandle(hSend);
		InternetCloseHandle(hRequest);
		if(session > 0) InternetCloseHandle(session); session = -1;
		if(connect > 0) InternetCloseHandle(connect); connect = -1;

		// Print("Data Send : toStr");
		return(toStr);
	}
}